﻿local cfg -- config we'll define later
local addon, ns = ... --get addon namespace
local L = OILVL_L

local HELM, NECK, SHOULDER, SHIRT, CHEST, WAIST, LEGS, FEET, WRISTS, HANDS, RING1, RING2, TRINK1, TRINK2, BACK, WEP, OFFHAND = 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17;

local LibQTip = LibStub('LibQTip-1.0');
local otooltip;
local otooltip2;

local ORole = {
	["TANK"]   = {"Interface\\LFGFrame\\LFGRole", 0.5, 0.75, 0, 1},
	["HEALER"] = {"Interface\\LFGFrame\\LFGRole", 0.75, 1, 0, 1},
	["DAMAGER"] = {"Interface\\LFGFrame\\LFGRole", 0.25, 0.5, 0, 1},
	["NONE"] = {"",0,0,0,0}
}

local ORank = {
	[0] = {""},
	[1] = {"Interface\\GROUPFRAME\\UI-GROUP-ASSISTANTICON"},
	[2] = {"Interface\\GROUPFRAME\\UI-Group-LeaderIcon"},
}
local ospec={};
local oispec;
for oispec = 62, 66 do
	local _, name, _, _, _, _, _ = GetSpecializationInfoByID(oispec)
	ospec[oispec] = name;
end
for oispec = 70, 73 do
	local _, name, _, _, _, _, _ = GetSpecializationInfoByID(oispec)
	ospec[oispec] = name;
end
for oispec = 102, 105 do
	local _, name, _, _, _, _, _ = GetSpecializationInfoByID(oispec)
	ospec[oispec] = name;
end
for oispec = 250, 270 do
	local _, name, _, _, _, _, _ = GetSpecializationInfoByID(oispec)
	ospec[oispec] = name;
end

local GarroshBoA = {
	[3] = {105679,105673,105677,105672,105678,105671,105675,105670,105674,105680},
	[2] = {104405,104403,104406,104404,104401,104400,104402,104399,104409,104407},
	[1] = {105692,105686,105690,105685,105691,105684,105688,105683,105687,105693},
}

local GarroshBoAScaling = {
		  -- M,  H,  N
	[90] = {582,569,556},
	[91] = {586,574,562},
	[92] = {590,579,569},
	[93] = {593,584,575},
	[94] = {597,589,582},
	[95] = {601,595,588},
	[96] = {605,600,594},
	[97] = {609,605,601},
	[98] = {612,610,607},
	[99] = {616,615,614},
	[100] = {620,620,620},
}
			
local classcolor = {
	[6]= "|cFFC41F3B",
	[11]= "|cFFFF7D0A",
	[3]= "|cFFABD473",
	[8]= "|cFF69CCF0",
	[10]= "|cFF00FF96",
	[2]= "|cFFF58CBA",
	[5]= "|cFFFFFFFF",
	[4]= "|cFFFFF569",
	[7]= "|cFF0070DE",
	[9]= "|cFF9482C9",
	[1]= "|cFFC79C6E",
	[0]= "|cFFFFFF00",
}

local Oilvlrole = {};
local Oilvlrank = {};
local ItemUpgradeInfo = LibStub("LibItemUpgradeInfo-1.0")
local Oilvltimer = LibStub("AceAddon-3.0"):NewAddon("OilvlTimer", "AceTimer-3.0")

local OILVL = CreateFrame("Frame");
local oilvlframesw=false;
local oilvlframedata = {};
oilvlframedata.guid = {};
oilvlframedata.name = {};
oilvlframedata.ilvl = {};
oilvlframedata.me = {}; -- miss enchant
oilvlframedata.mg = {}; -- miss gem
oilvlframedata.spec = {}; -- specialization
oilvlframedata.role = {};

local OILVL_Unit="";
local OTilvl=0;
local OTmia=0;
local OTTop=0;	
local Omover=0;
local omover2=0;
local OTCurrent=""; -- current raid frame
local OTCurrent2=""; -- current unit id
local OTCurrent3=""; -- current raid frame number
local ountrack=true;
local ail=0; -- average item level
local ailtank=0;
local aildps=0;
local ailheal=0;
local NumRole = {};
NumRole["TANK"] = 0;
NumRole["DAMAGER"] = 0;
NumRole["HEALER"] = 0;
local miacount=0;
local miaunit={};
local rpunit="";
local rpsw=false;

local OgemFrame = CreateFrame('GameTooltip', 'OSocketTooltip', UIParent, 'GameTooltipTemplate');
function OItemAnalysis_CountEmptySockets(itemLink)
	local count = 0;

	for textureCount = 1, 10 do
		if _G["OSocketTooltipTexture"..textureCount] then
			_G["OSocketTooltipTexture"..textureCount]:SetTexture("");
		end
	end 
		
	OgemFrame:SetOwner(UIParent, 'ANCHOR_NONE');
	OgemFrame:ClearLines();
	OgemFrame:SetHyperlink(itemLink);
		
	for textureCount = 1, 10 do
		local temp = _G["OSocketTooltipTexture"..textureCount]:GetTexture();
		
		if temp and temp == "Interface\\ItemSocketingFrame\\UI-EmptySocket-Meta" then 
			count = count + 1;
		end
		if temp and temp == "Interface\\ItemSocketingFrame\\UI-EmptySocket-Red" then 
			count = count + 1;
		end
		if temp and temp == "Interface\\ItemSocketingFrame\\UI-EmptySocket-Yellow" then 
			count = count + 1;			
		end
		if temp and temp == "Interface\\ItemSocketingFrame\\UI-EmptySocket-Blue" then 
			count = count + 1;
		end
		if temp and temp == "Interface\\ItemSocketingFrame\\UI-EmptySocket-Prismatic" then 
			count = count + 1;
		end 
	end
	OgemFrame:Hide();
	return count;
end;

function oClassColor(unitid)
	local _, _, cclass = UnitClass(unitid);
	if classcolor[cclass] ~= nil then
		return classcolor[cclass];
	else
		return "|cFFFFFF00";
	end
end
-- OT Check Raid Item Level
function oilvl(unit)
	if not UnitAffectingCombat("player") then
		OILVL_Unit=unit;
		if CheckInteractDistance(OILVL_Unit, 1) and CanInspect(OILVL_Unit) then
			OILVL:RegisterEvent("INSPECT_READY");
			NotifyInspect(OILVL_Unit);
			local htex4 = _G[OTCurrent]:CreateTexture()
			htex4:SetTexture(0,1,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			_G[OTCurrent]:SetNormalTexture(htex4)
		else
			OILVL_Unit="";
			miacount=0;
			miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
			local ntex4 = _G[OTCurrent]:CreateTexture()
			ntex4:SetTexture(0.2,0.2,0.2,0.5)
			ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ntex4:SetAllPoints()	
			_G[OTCurrent]:SetNormalTexture(ntex4)
			OTCurrent = "";
			OTCurrent2 = "";
			OTCurrent3 = "";
			ountrack=true;			
		end
	end
end
	
-- Get Raid Frame Item Level
function ORfbIlvl(ounit)
if not UnitAffectingCombat("player") and ounit ~= "" then
	local i=0;
	OTCurrent3 = tonumber(ounit);
	if IsInRaid() then
		OTCurrent = "OILVLRAIDFRAME"..ounit;		
		OTCurrent2 = "raid"..ounit;
		if _G[OTCurrent] == nil then return -1 end
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			oilvlframedata.name[tonumber(ounit)] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
			oilvl(OTCurrent2);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		if ounit == "1" or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if _G[OTCurrent] == nil then return -1 end
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[1] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(tonumber(ounit)-1);
			if _G[OTCurrent] == nil then return -1 end
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[tonumber(ounit)] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		if ounit == "1"  or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if _G[OTCurrent] == nil then return -1 end
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[1] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(tonumber(ounit)-1);
			if _G[OTCurrent] == nil then return -1 end
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[tonumber(ounit)] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		end
	else
		OTCurrent = "OILVLRAIDFRAME1";
		OTCurrent2 = "player";
		if _G[OTCurrent] == nil then return -1 end
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			oilvlframedata.name[1] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
			oilvl(OTCurrent2);
		end
	end
end
end

function OilvlSetRole(ounit, orole)
	Oilvlrole[ounit]:SetTexture(ORole[orole][1]);
	Oilvlrole[ounit]:SetTexCoord(ORole[orole][2],ORole[orole][3],ORole[orole][4],ORole[orole][5]);
	oilvlframedata.role[ounit] = orole;
	if orole ~= "NONE" then NumRole[orole] = NumRole[orole] + 1; end
end

function OilvlSetRank(ounit, orole)
	Oilvlrank[ounit]:SetTexture(ORank[orole][1]);
end

function OilvlSetMouseoverTooltips(oframe, ounit)
	oframe:SetAttribute("unit", ounit);
	--[[oframe:SetScript("OnEnter", function(self)
		if not LibQTip:IsAcquired("Oraidprog") then
			OilvlTooltip:SetOwner(oframe, "ANCHOR_BOTTOMRIGHT");
			OilvlTooltip:SetUnit(ounit)
			local i = tonumber(self:GetName():gsub("OILVLRAIDFRAME", "").."");
			if oilvlframedata.spec[i] ~= "" then
				OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
				OilvlTooltip:AddLine("Spec: |cFF00FF00"..oilvlframedata.spec[i]);
			end
			if oilvlframedata.me[i] ~= "" then
				OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
				OilvlTooltip:AddLine("Please enchant:\n|cFF00FF00"..oilvlframedata.me[i]);
			end
			OilvlTooltip:Show()
			if not rpsw and CheckInteractDistance(ounit, 1) and UnitExists(ounit) and cfg.oilvlms then
				Omover2=1;
				OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
				ClearAchievementComparisonUnit();
				SetAchievementComparisonUnit(ounit);
				rpsw=true;
				rpunit=ounit;
			end
		end
	end)]]-- 
end

function OilvlRunMouseoverTooltips(oframe)
	local ounit = oframe:GetAttribute("unit") 
	if not LibQTip:IsAcquired("Oraidprog") then
		OilvlTooltip:SetOwner(oframe, "ANCHOR_BOTTOMRIGHT");
		OilvlTooltip:SetUnit(ounit)
		local i = tonumber(oframe:GetName():gsub("OILVLRAIDFRAME", "").."");
		if oilvlframedata.spec[i] ~= "" then
			OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
			OilvlTooltip:AddLine(SPECIALIZATION.." |cFF00FF00"..oilvlframedata.spec[i]);
		end
		if oilvlframedata.me[i] ~= "" then
			OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
			OilvlTooltip:AddLine(ENSCRIBE..":\n|cFF00FF00"..oilvlframedata.me[i]);
		end
		if oilvlframedata.mg[i] ~= "" then
			OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
			OilvlTooltip:AddLine(L["Gem"]..":\n|cFF00FF00"..oilvlframedata.mg[i]);
		end
		OilvlTooltip:Show()
		if not rpsw and CheckInteractDistance(ounit, 1) and UnitExists(ounit) then
			Omover2=1;
			ClearAchievementComparisonUnit();
			--print("OilvlRunMouseoverTooltips ClearAchievementComparisonUnit")
			OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")			
			SetAchievementComparisonUnit(ounit);
			rpsw=true;
			rpunit=ounit;
		end
	end
end


function oilvlcheckunknown()
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		for i = 1, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("raid"..i)..GetUnitName("raid"..i,""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("raid"..i);
				oilvlframedata.name[i] = GetUnitName("raid"..i,""):gsub("%-.+", "");
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.mg[i] = "";
				oilvlframedata.spec[i] = "";
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
		for i = 2, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("party"..(i-1))..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
				oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.mg[i] = "";
				oilvlframedata.spec[i] = "";
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
		for i = 2, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("party"..(i-1))..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
				oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.mg[i] = "";
				oilvlframedata.spec[i] = "";
			end
		end
	else
		return 0
	end
end

function OILVLCheckUpdate()
if not UnitAffectingCombat("player") and OILVL_Unit == "" and oilvlframesw then
	oilvlcheckunknown();
	ountrack=false;
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i] then break; end
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end
		msg = msg:sub(11):gsub("\n|r|cFF00FF00",":"):gsub("\n|r|cFFFF0000",":");
		local ochar, ilvl = strsplit(":",msg,2)	
		if ilvl == nil or ilvl == "" then
			ountrack = true;
			if IsInRaid() then
				if CheckInteractDistance("raid"..i, 1) and CanInspect("raid"..i) then ORfbIlvl(i); return 0; end
			elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
				if i == 1 then
					ORfbIlvl(i); return 0;
				else
					if CheckInteractDistance("party"..(i-1), 1) and CanInspect("party"..(i-1)) then ORfbIlvl(i); return 0; end
				end
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				if i == 1 then
					ORfbIlvl(i); return 0;
				else
					if CheckInteractDistance("party"..(i-1), 1) and CanInspect("party"..(i-1)) then ORfbIlvl(i); return 0; end
				end
			else
				ORfbIlvl(1); return 0;
			end
		end
	end	
end
end
	
function OVILRefresh()
if not UnitAffectingCombat("player") and oilvlframesw then
	local i=0;
	local rnum=0;
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
	OILVL_Unit="";
	for i = 1, 40 do
		-- reset the color of all frames
		if not _G["OILVLRAIDFRAME"..i]  then break; end
		local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
		ntex4:SetTexture(0.2,0.2,0.2,0.5)
		ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex4:SetAllPoints()	
		_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)			
		
		-- reset data
		oilvlframedata.guid[i] = "";
		oilvlframedata.name[i] = "";
		oilvlframedata.ilvl[i] = "";
		oilvlframedata.me[i] = "";
		oilvlframedata.mg[i] = "";
		oilvlframedata.spec[i] = "";
	end
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		if rnum < 16 then
			OIVLFRAME:SetWidth(310);
		end
		if rnum >= 16 and rnum <= 20 then
			OIVLFRAME:SetWidth(348);
		end
		if rnum >= 21 and rnum <= 25 then
			OIVLFRAME:SetWidth(430);
		end
		if rnum >= 26 and rnum <= 30 then
			OIVLFRAME:SetWidth(512);
		end
		if rnum >= 31 and rnum <= 35 then
			OIVLFRAME:SetWidth(594);
		end
		if rnum >= 36 and rnum <= 40 then
			OIVLFRAME:SetWidth(676);
		end
		for i = rnum+1, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
		end
		NumRole["TANK"] = 0;
		NumRole["DAMAGER"] = 0;
		NumRole["HEALER"] = 0;
		for i = 1, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("raid"..i)..GetUnitName("raid"..i,""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("raid"..i,""));
			local _, rank, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
			OilvlSetRank(i, rank);
			oilvlframedata.guid[i] = UnitGUID("raid"..i);
			oilvlframedata.name[i] = GetUnitName("raid"..i,""):gsub("%-.+", "");
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "raid"..i);
			if oilvlframedata.role[i] == "TANK" then
			
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
		for i = rnum, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
		end
		NumRole["TANK"] = 0;
		NumRole["DAMAGER"] = 0;
		NumRole["HEALER"] = 0;
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText(oClassColor("player")..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.mg[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
		for i = 2, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("party"..(i-1))..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
			if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
			oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
			oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
		end
		OIVLFRAME:SetWidth(310);
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
		for i = rnum, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
		end
		NumRole["TANK"] = 0;
		NumRole["DAMAGER"] = 0;
		NumRole["HEALER"] = 0;
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText(oClassColor("player")..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.mg[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
		for i = 2, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("party"..(i-1))..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
			if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
			oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
			oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
		end
		OIVLFRAME:SetWidth(310);
	else
		for i = 2, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
		end
		NumRole["TANK"] = 0;
		NumRole["DAMAGER"] = 0;
		NumRole["HEALER"] = 0;
		OILVLRAIDFRAME1:SetText(oClassColor("player")..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		OilvlSetRank(1, 0);
		OIVLFRAME:SetWidth(310);
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.mg[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
	end
end
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
end
-- Same as OVILRefresh(), but do not clear item level.
function OilvlCheckFrame()
if not UnitAffectingCombat("player") and oilvlframesw then
	local i=0;
	local j=0;
	local rnum=0;
	local td = {};
	td.guid = {};
	td.name = {};
	td.ilvl = {};
	td.me = {};
	td.mg = {};
	td.spec = {};
	for i=1,40 do
		td.guid[i] = "";
		td.name[i] = "";
		td.ilvl[i] = "";
		td.me[i] = "";
		td.mg[i] = "";
		td.spec[i] = "";
	end
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
	OILVL_Unit="";
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		if rnum < 16 then
			OIVLFRAME:SetWidth(310);
		end		
		if rnum >= 16 and rnum <= 20 then
			OIVLFRAME:SetWidth(348);
		end
		if rnum >= 21 and rnum <= 25 then
			OIVLFRAME:SetWidth(430);
		end
		if rnum >= 26 and rnum <= 30 then
			OIVLFRAME:SetWidth(512);
		end
		if rnum >= 31 and rnum <= 35 then
			OIVLFRAME:SetWidth(594);
		end
		if rnum >= 36 and rnum <= 40 then
			OIVLFRAME:SetWidth(676);
		end

		for j=1, rnum do
			for i=1, 40 do
				if oilvlframedata.guid[i] == "" then break end
				if UnitGUID("raid"..j) == oilvlframedata.guid[i] then
					td.guid[j] = oilvlframedata.guid[i];
					td.name[j] = oilvlframedata.name[i];
					td.ilvl[j] = oilvlframedata.ilvl[i];
					td.me[j] = oilvlframedata.me[i];
					td.mg[j] = oilvlframedata.mg[i];
					td.spec[j] = oilvlframedata.spec[i];
					break;
				end
			end
			if td.guid[j] == "" then
				td.guid[j] = UnitGUID("raid"..j);
				td.name[j] = GetUnitName("raid"..j,""):gsub("%-.+", "");
				td.ilvl[j] = "";
				td.me[j] = "";
				td.spec[j] = "";
			end
		end

		for i = rnum+1, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
		end
		NumRole["TANK"] = 0;
		NumRole["DAMAGER"] = 0;
		NumRole["HEALER"] = 0;
		for i = 1, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("raid"..i)..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("raid"..i,""));
			local _, rank, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
			OilvlSetRank(i, rank);
			oilvlframedata.guid[i] = td.guid[i];
			oilvlframedata.name[i] = td.name[i];
			oilvlframedata.ilvl[i] = td.ilvl[i];
			oilvlframedata.me[i] = td.me[i];
			oilvlframedata.mg[i] = td.mg[i];
			oilvlframedata.spec[i] = td.spec[i];
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "raid"..i);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) - 1		
		if rnum > 0 then
			for j=1, rnum do
				for i=2, 5 do
					if oilvlframedata.guid[i] == "" then break end
					if UnitGUID("party"..j) == oilvlframedata.guid[i] then
						td.guid[j+1] = oilvlframedata.guid[i];
						td.name[j+1] = oilvlframedata.name[i];
						td.ilvl[j+1] = oilvlframedata.ilvl[i];
						td.me[j+1] = oilvlframedata.me[i];
						td.mg[j+1] = oilvlframedata.mg[i];
						td.spec[j+1] = oilvlframedata.spec[i];
						break;
					end
				end
				if td.guid[j+1] == "" then
					td.guid[j+1] = UnitGUID("party"..j);
					td.name[j+1] = GetUnitName("party"..j,""):gsub("%-.+", "");
					td.ilvl[j+1] = "";
					td.me[j+1] = "";
					td.spec[j+1] = "";
				end
			end
			for i = rnum+1, 40 do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("");
				_G["OILVLRAIDFRAME"..i]:Hide();
				oilvlframedata.guid[i] = "";
				oilvlframedata.name[i] = "";
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.mg[i] = "";
				oilvlframedata.spec[i] = "";
			end
			NumRole["TANK"] = 0;
			NumRole["DAMAGER"] = 0;
			NumRole["HEALER"] = 0;
			OILVLRAIDFRAME1:Show();
			OilvlSetRole(1, UnitGroupRolesAssigned("player"));
			OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
			if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
			for i = 2, (rnum+1) do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("party"..(i-1))..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
				_G["OILVLRAIDFRAME"..i]:Show();
				OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
				if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
				oilvlframedata.guid[i] = td.guid[i];
				oilvlframedata.name[i] = td.name[i];
				oilvlframedata.ilvl[i] = td.ilvl[i];
				oilvlframedata.me[i] = td.me[i];
				oilvlframedata.mg[i] = td.mg[i];
				oilvlframedata.spec[i] = td.spec[i];
				OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
			end
			OIVLFRAME:SetWidth(310);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) - 1
		if rnum > 0 then
			for j=1, rnum do
				for i=2, 5 do
					if oilvlframedata.guid[i] == "" then break end
					if UnitGUID("party"..j) == oilvlframedata.guid[i] then
						td.guid[j+1] = oilvlframedata.guid[i];
						td.name[j+1] = oilvlframedata.name[i];
						td.ilvl[j+1] = oilvlframedata.ilvl[i];
						td.me[j+1] = oilvlframedata.me[i];
						td.mg[j+1] = oilvlframedata.mg[i];
						td.spec[j+1] = oilvlframedata.spec[i];
						break;
					end
				end
				if td.guid[j+1] == "" then
					td.guid[j+1] = UnitGUID("party"..j);
					td.name[j+1] = GetUnitName("party"..j,""):gsub("%-.+", "");
					td.ilvl[j+1] = "";
					td.me[j+1] = "";
					td.spec[j+1] = "";
				end
			end
			for i = rnum+1, 40 do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("");
				_G["OILVLRAIDFRAME"..i]:Hide();
				oilvlframedata.guid[i] = "";
				oilvlframedata.name[i] = "";
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.mg[i] = "";
				oilvlframedata.spec[i] = "";
			end
			NumRole["TANK"] = 0;
			NumRole["DAMAGER"] = 0;
			NumRole["HEALER"] = 0;
			OILVLRAIDFRAME1:Show();
			OilvlSetRole(1, UnitGroupRolesAssigned("player"));
			OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
			if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
			for i = 2, (rnum+1) do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText(oClassColor("party"..(i-1))..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
				_G["OILVLRAIDFRAME"..i]:Show();
				OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
				if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
				oilvlframedata.guid[i] = td.guid[i];
				oilvlframedata.name[i] = td.name[i];
				oilvlframedata.ilvl[i] = td.ilvl[i];
				oilvlframedata.me[i] = td.me[i];
				oilvlframedata.mg[i] = td.mg[i];
				oilvlframedata.spec[i] = td.spec[i];
				OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
			end
			OIVLFRAME:SetWidth(310);
		end
	else
		OIVLFRAME:SetWidth(310);
		for i = 2, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.mg[i] = "";
			oilvlframedata.spec[i] = "";
		end
		NumRole["TANK"] = 0;
		NumRole["DAMAGER"] = 0;
		NumRole["HEALER"] = 0;
		OILVLRAIDFRAME1:SetText(oClassColor("player")..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		OilvlSetRank(1, 0);
		OIVLFRAME:SetWidth(310);
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.mg[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
	end
end
	ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3="";
end

local function round(number, digits)
    return tonumber(string.format("%." .. (digits or 0) .. "f", number))
end

function oilvlcheckrange()
if not UnitAffectingCombat("player") and oilvlframesw then
	local i=0;
	local rnum=0;
	local total=0;
	local n=0;
	local ntank=0;
	local totaltank=0;
	local ndps=0;
	local totaldps=0;
	local nheal=0;
	local totalheal=0;
	ail=0; ailtank=0; aildps=0; ailheal=0;	
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		for i = 1, rnum do
			if not CheckInteractDistance("raid"..i, 1) then
				if OTCurrent2 == "raid"..i then
					miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
					ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3=""; OILVL_Unit="";
				end
				local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)
			else
				local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)					
			end
			
			if oilvlframedata.ilvl[i] ~= "" then 
				n = n + 1;
				total = total + oilvlframedata.ilvl[i];
				if oilvlframedata.role[i] == "TANK" then
					ntank = ntank + 1;
					totaltank = totaltank + oilvlframedata.ilvl[i];
				end
				if oilvlframedata.role[i] == "DAMAGER" then
					ndps = ndps + 1;
					totaldps = totaldps + oilvlframedata.ilvl[i];
				end
				if oilvlframedata.role[i] == "HEALER" then
					nheal = nheal + 1;
					totalheal = totalheal + oilvlframedata.ilvl[i];
				end
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) - 1
		for i = 1, rnum do
			if not CheckInteractDistance("party"..i, 1) then 
				if OTCurrent2 == "party"..i then
					miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
					ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3=""; OILVL_Unit="";
				end
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			else
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			end			
			if oilvlframedata.ilvl[i] ~= "" then 
				n = n + 1;
				total = total + oilvlframedata.ilvl[i];
				if oilvlframedata.role[i] == "TANK" then
					ntank = ntank + 1;
					totaltank = totaltank + oilvlframedata.ilvl[i];
				end
				if oilvlframedata.role[i] == "DAMAGER" then
					ndps = ndps + 1;
					totaldps = totaldps + oilvlframedata.ilvl[i];
				end
				if oilvlframedata.role[i] == "HEALER" then
					nheal = nheal + 1;
					totalheal = totalheal + oilvlframedata.ilvl[i];
				end
			end			
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then		
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) - 1
		for i = 1, rnum do
			if not CheckInteractDistance("party"..i, 1) then 
				if OTCurrent2 == "party"..i then
					miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
					ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3=""; OILVL_Unit="";
				end
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			else
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			end
			if oilvlframedata.ilvl[i] ~= "" then 
				n = n + 1;
				total = total + oilvlframedata.ilvl[i];
				if oilvlframedata.role[i] == "TANK" then
					ntank = ntank + 1;
					totaltank = totaltank + oilvlframedata.ilvl[i];
				end
				if oilvlframedata.role[i] == "DAMAGER" then
					ndps = ndps + 1;
					totaldps = totaldps + oilvlframedata.ilvl[i];
				end
				if oilvlframedata.role[i] == "HEALER" then
					nheal = nheal + 1;
					totalheal = totalheal + oilvlframedata.ilvl[i];
				end
			end			
		end
	end
	if OTCurrent ~= "" then
		local htex4 = _G[OTCurrent]:CreateTexture()
		htex4:SetTexture(0,1,1,0.5)
		htex4:SetTexCoord(0, 0.625, 0, 0.6875)
		htex4:SetAllPoints()
		_G[OTCurrent]:SetNormalTexture(htex4)	
	end
	if ountrack and not UnitAffectingCombat("player") then
		Oilvltimer:ScheduleTimer(OILVLCheckUpdate,1);
	end
	if OILVL_Unit ~= "" then ORfbIlvl(OTCurrent3); end

	-- Calculate Average Item Level
	if IsInRaid() or IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInGroup(LE_PARTY_CATEGORY_HOME) then
		ONumTank:Show(); ONumDPS:Show(); ONumHeal:Show();
		if(n ~= 0) then ail = round(total/n,1); end
		if(ntank ~= 0) then ailtank = round(totaltank/ntank,1); end
		if(ndps ~= 0) then aildps = round(totaldps/ndps,1); end
		if(nheal ~= 0) then ailheal = round(totalheal/nheal,1); end
		if ail then
			OilvlAIL:SetText(L["Average Item Level"]..": "..ail);
		else
			OilvlAIL:SetText(L["Average Item Level"]..": 0");
			ail = 0;
		end
		if ailtank then
			OilvlAIL_TANK:SetText(NumRole["TANK"].." ("..ailtank..")");
		else
			OilvlAIL_TANK:SetText(NumRole["TANK"]);
			ailtank = 0;
		end
		if aildps then
			OilvlAIL_DPS:SetText(NumRole["DAMAGER"].." ("..aildps..")");
		else
			OilvlAIL_DPS:SetText(NumRole["DAMAGER"]);
			aildps = 0;
		end
		if ailheal then
			OilvlAIL_HEAL:SetText(NumRole["HEALER"].." ("..ailheal..")");
		else
			OilvlAIL_HEAL:SetText(NumRole["HEALER"]);
			ailheal = 0;
		end
	else
		ONumTank:Hide(); ONumDPS:Hide(); ONumHeal:Hide();
		OilvlAIL:SetText(L["Average Item Level"]..": "..oilvlframedata.ilvl[1]);
		ail = oilvlframedata.ilvl[1];
		OilvlAIL_TANK:SetText(""); OilvlAIL_DPS:SetText(""); OilvlAIL_HEAL:SetText("");
	end
end
end

function OCheckSendMark()
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		if _G["Oilvlmark"..i]:IsVisible() then
			return true;
		end
	end
	return false
end

function OResetSendMark()
	for i = 1, 40 do
		if _G["OILVLRAIDFRAME"..i] == nil then return -1 end
		_G["Oilvlmark"..i]:Hide();
	end
end

function OSendToTarget()
	local i=0;
	if not UnitExists("target") then 
		return -1;
	end
	SendChatMessage(L["Item Level"]..":", "WHISPER", nil, UnitName("target"));
	if not OCheckSendMark() then
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			local msg = _G["OILVLRAIDFRAME"..i]:GetText();
			if msg == nil then
				break;
			end		
			msg = msg:sub(11);
			msg = msg:gsub("\n|r|cFF00FF00",": ");
			if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
				msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
			end
			if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
				msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
			end
			SendChatMessage(msg, "WHISPER", nil, UnitName("target"));
		end
		SendChatMessage(L["Average Item Level"].."("..NumRole["TANK"].." "..TANK.."): "..ailtank, "WHISPER", nil, UnitName("target"));
		SendChatMessage(L["Average Item Level"].."("..NumRole["HEALER"].." "..HEALER.."): "..ailheal, "WHISPER", nil, UnitName("target"));
		SendChatMessage(L["Average Item Level"].."("..NumRole["DAMAGER"].." "..DAMAGER.."): "..aildps, "WHISPER", nil, UnitName("target"));
		SendChatMessage(L["Average Item Level"]..": "..ail, "WHISPER", nil, UnitName("target"));
	else
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			if _G["Oilvlmark"..i]:IsVisible() then
				local msg = _G["OILVLRAIDFRAME"..i]:GetText();
				if msg == nil then
					break;
				end		
				msg = msg:sub(11);
				msg = msg:gsub("\n|r|cFF00FF00",": ");
				if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
					msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
				end
				if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
					msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
				end
				SendChatMessage(msg, "WHISPER", nil, UnitName("target"));
			end
		end		
	end
end

function OSendToParty()
	local i=0;
	SendChatMessage(L["Item Level"]..":", "PARTY");
	if not OCheckSendMark() then
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			local msg = _G["OILVLRAIDFRAME"..i]:GetText();
			if msg == nil then
				break;
			end		
			msg = msg:sub(11);
			msg = msg:gsub("\n|r|cFF00FF00",": ");
			if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
				msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
			end
			if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
				msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
			end
			SendChatMessage(msg, "PARTY");
		end
		SendChatMessage(L["Average Item Level"].."("..NumRole["TANK"].." "..TANK.."): "..ailtank, "PARTY");
		SendChatMessage(L["Average Item Level"].."("..NumRole["HEALER"].." "..HEALER.."): "..ailheal, "PARTY");
		SendChatMessage(L["Average Item Level"].."("..NumRole["DAMAGER"].." "..DAMAGER.."): "..aildps, "PARTY");
		SendChatMessage(L["Average Item Level"]..": "..ail, "PARTY");
	else
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			if _G["Oilvlmark"..i]:IsVisible() then
				local msg = _G["OILVLRAIDFRAME"..i]:GetText();
				if msg == nil then
					break;
				end		
				msg = msg:sub(11);
				msg = msg:gsub("\n|r|cFF00FF00",": ");
				if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
					msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
				end
				if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
					msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
				end
				SendChatMessage(msg, "PARTY");
			end
		end		
	end
end

function OSendToInstance()
	local i=0;
	SendChatMessage(L["Item Level"]..":", "INSTANCE_CHAT");
	if not OCheckSendMark() then
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			local msg = _G["OILVLRAIDFRAME"..i]:GetText();
			if msg == nil then
				break;
			end		
			msg = msg:sub(11);
			msg = msg:gsub("\n|r|cFF00FF00",": ");
			if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
				msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
			end
			if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
				msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
			end
			SendChatMessage(msg, "INSTANCE_CHAT");
		end
		SendChatMessage(L["Average Item Level"].."("..NumRole["TANK"].." "..TANK.."): "..ailtank, "INSTANCE_CHAT");
		SendChatMessage(L["Average Item Level"].."("..NumRole["HEALER"].." "..HEALER.."): "..ailheal, "INSTANCE_CHAT");
		SendChatMessage(L["Average Item Level"].."("..NumRole["DAMAGER"].." "..DAMAGER.."): "..aildps, "INSTANCE_CHAT");
		SendChatMessage(L["Average Item Level"]..": "..ail, "INSTANCE_CHAT");
	else
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			if _G["Oilvlmark"..i]:IsVisible() then
				local msg = _G["OILVLRAIDFRAME"..i]:GetText();
				if msg == nil then
					break;
				end		
				msg = msg:sub(11);
				msg = msg:gsub("\n|r|cFF00FF00",": ");
				if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
					msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
				end
				if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
					msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
				end
				SendChatMessage(msg, "INSTANCE_CHAT");
			end
		end		
	end
end

function OSendToGuild()
	local i=0;
	SendChatMessage(L["Item Level"]..":", "GUILD");
	if not OCheckSendMark() then
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			local msg = _G["OILVLRAIDFRAME"..i]:GetText();
			if msg == nil then
				break;
			end		
			msg = msg:sub(11);
			msg = msg:gsub("\n|r|cFF00FF00",": ");
			if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
				msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
			end
			if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
				msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
			end
			SendChatMessage(msg, "GUILD");
		end
		SendChatMessage(L["Average Item Level"].."("..NumRole["TANK"].." "..TANK.."): "..ailtank, "GUILD");
		SendChatMessage(L["Average Item Level"].."("..NumRole["HEALER"].." "..HEALER.."): "..ailheal, "GUILD");
		SendChatMessage(L["Average Item Level"].."("..NumRole["DAMAGER"].." "..DAMAGER.."): "..aildps, "GUILD");
		SendChatMessage(L["Average Item Level"]..": "..ail, "GUILD");
	else
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			if _G["Oilvlmark"..i]:IsVisible() then
				local msg = _G["OILVLRAIDFRAME"..i]:GetText();
				if msg == nil then
					break;
				end		
				msg = msg:sub(11);
				msg = msg:gsub("\n|r|cFF00FF00",": ");
				if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
					msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
				end
				if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
					msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
				end
				SendChatMessage(msg, "GUILD");
			end
		end		
	end
end

function OSendToRaid()
	local i=0;
	SendChatMessage(L["Item Level"]..":", "RAID");
	if not OCheckSendMark() then
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			local msg = _G["OILVLRAIDFRAME"..i]:GetText();
			if msg == nil then
				break;
			end		
			msg = msg:sub(11);
			msg = msg:gsub("\n|r|cFF00FF00",": ");
			if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
				msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
			end
			if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
				msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
			end
			SendChatMessage(msg, "RAID");
		end
		SendChatMessage(L["Average Item Level"].."("..NumRole["TANK"].." "..TANK.."): "..ailtank, "RAID");
		SendChatMessage(L["Average Item Level"].."("..NumRole["HEALER"].." "..HEALER.."): "..ailheal, "RAID");
		SendChatMessage(L["Average Item Level"].."("..NumRole["DAMAGER"].." "..DAMAGER.."): "..aildps, "RAID");
		SendChatMessage(L["Average Item Level"]..": "..ail, "RAID");
	else
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			if _G["Oilvlmark"..i]:IsVisible() then
				local msg = _G["OILVLRAIDFRAME"..i]:GetText();
				if msg == nil then
					break;
				end		
				msg = msg:sub(11);
				msg = msg:gsub("\n|r|cFF00FF00",": ");
				if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
					msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
				end
				if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
					msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
				end
				SendChatMessage(msg, "RAID");
			end
		end		
	end
end

function OSendToOfficer()
	local i=0;
	SendChatMessage(L["Item Level"]..":", "OFFICER");
	if not OCheckSendMark() then
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			local msg = _G["OILVLRAIDFRAME"..i]:GetText();
			if msg == nil then
				break;
			end		
			msg = msg:sub(11);
			msg = msg:gsub("\n|r|cFF00FF00",": ");
			if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
				msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
			end
			if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
				msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
			end
			SendChatMessage(msg, "OFFICER");
		end
		SendChatMessage(L["Average Item Level"].."("..NumRole["TANK"].." "..TANK.."): "..ailtank, "OFFICER");
		SendChatMessage(L["Average Item Level"].."("..NumRole["HEALER"].." "..HEALER.."): "..ailheal, "OFFICER");
		SendChatMessage(L["Average Item Level"].."("..NumRole["DAMAGER"].." "..DAMAGER.."): "..aildps, "OFFICER");
		SendChatMessage(L["Average Item Level"]..": "..ail, "OFFICER");
	else
		for i = 1, 40 do
			if not _G["OILVLRAIDFRAME"..i]:IsShown() then
				break;
			end
			if _G["Oilvlmark"..i]:IsVisible() then
				local msg = _G["OILVLRAIDFRAME"..i]:GetText();
				if msg == nil then
					break;
				end		
				msg = msg:sub(11);
				msg = msg:gsub("\n|r|cFF00FF00",": ");
				if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
					msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
				end
				if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
					msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
				end
				SendChatMessage(msg, "OFFICER");
			end
		end		
	end
end

local function CopyEditBox(cname, cx, cy)
	local f = CreateFrame("ScrollFrame", cname.."Frame",UIParent,"UIPanelScrollFrameTemplate")
	f:SetPoint("CENTER", cx, cy)
	f:SetSize(310,310)
	f:SetFrameStrata("HIGH");
	f:SetMovable(true);
	f:EnableMouse(true);
	f:RegisterForDrag("LeftButton");
	f:SetScript("OnDragStart", f.StartMoving);
	f:SetScript("OnDragStop", function() f:StopMovingOrSizing();  end);
	
	local g = CreateFrame("EditBox", cname, f, InputBoxTemplate)
	g:SetAutoFocus(true)
	g:SetWidth(300)
	g:SetHeight(20)	
	g:SetMultiLine(true)
	g:SetScript("OnEscapePressed", function(self) 
		_G[cname.."Frame"]:Hide();
		_G[cname.."_bodyBackground"]:Hide();
	end)
	g:SetFontObject("ChatFontNormal")
	f:SetScrollChild(g)
	g:SetCursorPosition(0);
	f:Hide();

	h = CreateFrame("Button", cname.."_bodyBackground", UIParent)
	h:SetPoint("BOTTOMLEFT", f, -10,-10)
	h:SetPoint("TOPRIGHT", f, 27,10)
	h:SetBackdrop({
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true,
		tileSize = 16,
		edgeSize = 16
	})
	h:Hide();
end
	
CopyEditBox("OIlvlCopyEB", 0, 250)

local function obfbutton2(btnName, btnText, btnParent, btnTemplate, btnPoint, btnX, btnY, btnW, btnH, btnFunc)
	local button = CreateFrame("Button", btnName, btnParent, btnTemplate)
	button:SetPoint(btnPoint, btnX, btnY)
	button:SetWidth(btnW)
	button:SetHeight(btnH)
	
	button:SetText(btnText)
	button:SetNormalFontObject("GameFontNormal")
	
	local ntex = button:CreateTexture()
	ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex:SetAllPoints()	
	button:SetNormalTexture(ntex)
	
	local htex = button:CreateTexture()
	htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex:SetTexCoord(0, 0.625, 0, 0.6875)
	htex:SetAllPoints()
	button:SetHighlightTexture(htex)

	button:RegisterForClicks("LeftButtonDown");
	button:SetScript("OnClick", btnFunc);
	button:SetFrameStrata("TOOLTIP")
end

obfbutton2("OBFOkay2", "Okay", OIlvlCopyEBFrame, "OptionsButtonTemplate", "BOTTOMRIGHT", 0, 0, 50, 20, function() OIlvlCopyEB_bodyBackground:Hide(); OIlvlCopyEBFrame:Hide() end)

function OSendToCopy()
	local i=0;
	local ebmsg="";
	ebmsg = L["Item Level"]..":";
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = oilvlframedata.name[i]..":"..oilvlframedata.ilvl[i];
		if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
			msg = msg.." ("..ENSCRIBE.." "..oilvlframedata.me[i]..")";
		end
		if cfg.oilvlme and oilvlframedata.mg[i] ~= "" then
			msg = msg.." ("..L["Gem"].." "..oilvlframedata.mg[i]..")";
		end
		ebmsg = ebmsg.."\n"..msg;
	end
	ebmsg = ebmsg.."\n"..L["Average Item Level"].."("..NumRole["TANK"].." "..TANK.."): "..ailtank;
	ebmsg = ebmsg.."\n"..L["Average Item Level"].."("..NumRole["HEALER"].." "..HEALER.."): "..ailheal;
	ebmsg = ebmsg.."\n"..L["Average Item Level"].."("..NumRole["DAMAGER"].." "..DAMAGER.."): "..aildps;
	ebmsg = ebmsg.."\n"..L["Average Item Level"]..": "..ail;
	OIlvlCopyEB:SetText(ebmsg);
	OIlvlCopyEB:HighlightText(0)
	OIlvlCopyEBFrame:Show();
	OIlvlCopyEB_bodyBackground:Show();
	OIlvlCopyEBFrame:SetVerticalScroll(OIlvlCopyEBFrame:GetVerticalScrollRange())
end

function oilvlbutton(btnName, btnText, btnParent, btnTemplate, btnPoint, btnX, btnY, btnW, btnH, btnFunc)
	local button = CreateFrame("Button", btnName, btnParent, btnTemplate)
	button:SetPoint(btnPoint, btnX, btnY)
	button:SetWidth(btnW)
	button:SetHeight(btnH)
	
	button:SetText(btnText)
	button:SetNormalFontObject("GameFontNormal")
	
	local ntex = button:CreateTexture()
	ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex:SetAllPoints()	
	button:SetNormalTexture(ntex)
	
	local htex = button:CreateTexture()
	htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex:SetTexCoord(0, 0.625, 0, 0.6875)
	htex:SetAllPoints()
	button:SetHighlightTexture(htex)
	
	local ptex = button:CreateTexture()
	ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex:SetAllPoints()
	button:SetPushedTexture(ptex)

	button:RegisterForClicks("LeftButtonDown");
	button:SetScript("OnClick", btnFunc);
end

function oilvlcfgbutton(btnParent)
	local button = CreateFrame("Button", "oilvlcfgbutton", btnParent)
--	button:SetPoint("TOPLEFT", 39, 20)
	button:SetPoint("TOPLEFT", -10, 10)
	button:SetWidth(70)
	button:SetHeight(70)
	
--    local border = button:CreateTexture(nil, "BORDER");
--    border:SetSize(64,64);
--    border:SetPoint("CENTER", 12, -13);
--    border:SetTexture("Interface/Minimap/MiniMap-TrackingBorder");

	local ntex = button:CreateTexture(nil, "BACKGROUND")
--	ntex:SetSize(52,52);
	ntex:SetSize(120,120);
	ntex:SetPoint("CENTER",-1,1);
	ntex:SetTexture("Interface/AddOns/Oilvl/config.tga")
	
	local htex = button:CreateTexture()
--	htex:SetSize(40,40);
	htex:SetSize(70,70);
	htex:SetPoint("CENTER",-1,1);
	htex:SetTexture("Interface/Minimap/UI-Minimap-ZoomButton-Highlight")
	button:SetHighlightTexture(htex)
	
	button:RegisterForClicks("LeftButtonDown");
	button:SetScript("OnClick", function(self, button) 
		PlaySound("igMainMenuOption");
		InterfaceOptionsFrameTab2:Click();
		InterfaceOptionsFrame_OpenToCategory("O Item Level (OiLvL)")
	end);
end
	
function oilvlframe()
	local f = CreateFrame("Frame", "OIVLFRAME", UIParent, "ButtonFrameTemplate");
	f:SetWidth(676);
	f:SetHeight(350);
	f:SetFrameStrata("LOW");

-- set moveable and dragable	
	f:SetMovable(true);
	f:EnableMouse(true);
	f:RegisterForDrag("LeftButton");
	f:SetScript("OnDragStart", f.StartMoving);
	f:SetScript("OnDragStop", function() f:StopMovingOrSizing();  cfg.oilvlframeP, _, _, cfg.oilvlframeX, cfg.oilvlframeY = f:GetPoint() end);

-- Set Title
	f.text = f.text or f:CreateFontString(nil,"ARTWORK", "GameTooltipText");
	f.text:SetAllPoints(true);
	f.text:SetPoint("TOPLEFT",0,-6);
	f.text:SetJustifyH("CENTER");
	f.text:SetJustifyV("TOP");
	f.text:SetTextColor(1,1,1,1);
	f.text:SetText("O Item Level");	

--background texture
	local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetTexture(0.1,0.1,0.1,0.5)
	t:SetAllPoints(f)
	f.texture = t
	f:SetPoint("TOPLEFT",15,-60);
	
 --icon
--    local icon = f:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
--    icon:SetSize(60,60);
--    icon:SetPoint("TOPLEFT",-5,7);
--    icon:SetTexture("Interface/AddOns/Oilvl/config.tga");
--    icon:SetTexCoord(0,1,0,1);
--    f.icon = icon;

-- Average Item Level
	local adjustl = 5;
	local ail = f:CreateFontString("OilvlAIL","ARTWORK","GameFontHighlight")
	ail:SetPoint("BOTTOMLEFT",10,30)
	ail:SetText(L["Average Item Level"]..":");
	
	local ailtank = f:CreateFontString("OilvlAIL_TANK","ARTWORK","GameFontHighlight")
	ailtank:SetPoint("BOTTOMLEFT",28,50)
	ailtank:SetText(" ");
	local g = f:CreateTexture("ONumTank", "OVERLAY", nil, -8);
	g:SetSize(15,15);
	g:SetPoint("BOTTOMLEFT",10,50);
	g:SetTexture(ORole["TANK"][1]);	
	g:SetTexCoord(ORole["TANK"][2],ORole["TANK"][3],ORole["TANK"][4],ORole["TANK"][5]);

	local aildps = f:CreateFontString("OilvlAIL_DPS","ARTWORK","GameFontHighlight")
	aildps:SetPoint("BOTTOMLEFT",108+adjustl,50)
	aildps:SetText(" ");
	g = f:CreateTexture("ONumDPS", "OVERLAY", nil, -8);
	g:SetSize(15,15);
	g:SetPoint("BOTTOMLEFT",90+adjustl,50);
	g:SetTexture(ORole["DAMAGER"][1]);	
	g:SetTexCoord(ORole["DAMAGER"][2],ORole["DAMAGER"][3],ORole["DAMAGER"][4],ORole["DAMAGER"][5]);

	local ailheal = f:CreateFontString("OilvlAIL_HEAL","ARTWORK","GameFontHighlight")
	ailheal:SetPoint("BOTTOMLEFT",188+adjustl*2,50)
	ailheal:SetText(" ");
	g = f:CreateTexture("ONumHeal", "OVERLAY", nil, -8);
	g:SetSize(15,15);
	g:SetPoint("BOTTOMLEFT",170+adjustl*2,50);
	g:SetTexture(ORole["HEALER"][1]);	
	g:SetTexCoord(ORole["HEALER"][2],ORole["HEALER"][3],ORole["HEALER"][4],ORole["HEALER"][5]);
	
-- 	Enchantment Reminder
	local ercb = CreateFrame("CheckButton", "oilvlercb", f, "ChatConfigCheckButtonTemplate");
	ercb:SetPoint("BOTTOMRIGHT", -20,25);
	getglobal(ercb:GetName() .. 'Text'):SetText("ER");
	ercb.tooltip = L["Enable Sending Enchantment Reminder"];
	ercb:SetHitRectInsets(0,0,0,0);
	ercb:SetSize(25,25);
	ercb:SetScript("PostClick", function() cfg.oilvlme = oilvlercb:GetChecked(); oicb5:SetChecked(cfg.oilvlme) end);
	ercb:SetChecked(cfg.oilvlme);
	
-- Config Button
	oilvlcfgbutton(f);
--Refresh button
	oilvlbutton("OILVLREFRESH", LFG_LIST_REFRESH, f, "OptionsButtonTemplate", "TOPRIGHT", -6, -35, 60, 22, function(self, button) OVILRefresh() end);
--Party button
	oilvlbutton("OILVLParty", PARTY, f, "OptionsButtonTemplate", "TOPRIGHT", -68, -35, 60, 22, function(self, button) OSendToParty() end);
--Target button
	oilvlbutton("OILVLTarget", STATUS_TEXT_TARGET, f, "OptionsButtonTemplate", "TOPRIGHT", -130, -35, 60, 22, function(self, button) OSendToTarget() end);
--Reset button
	oilvlbutton("OILVLReset", RESET, f, "OptionsButtonTemplate", "TOPRIGHT", -192, -35, 60, 22, function(self, button) OResetSendMark() end);
--Instance button
	oilvlbutton("OILVLINSTANCE", BATTLEGROUND_INSTANCE, f, "OptionsButtonTemplate", "BOTTOMLEFT", 3, 3, 80, 22, function(self, button) OSendToInstance() end);
-- Guild button
	oilvlbutton("OILVLGUILD", CHAT_MSG_GUILD, f, "OptionsButtonTemplate", "BOTTOMLEFT", 85, 3, 50, 22, function(self, button) OSendToGuild() end);
-- Raid button
	if GetLocale() == "deDE" then
		oilvlbutton("OILVLRAID", "Raid", f, "OptionsButtonTemplate", "BOTTOMLEFT", 137, 3, 50, 22, function(self, button) OSendToRaid()	end);
	else
		oilvlbutton("OILVLRAID", CHAT_MSG_RAID, f, "OptionsButtonTemplate", "BOTTOMLEFT", 137, 3, 50, 22, function(self, button) OSendToRaid()	end);
	end
-- Officer button
	oilvlbutton("OILVLOfficer", GUILD_RANK1_DESC, f, "OptionsButtonTemplate", "BOTTOMLEFT", 190, 3, 60, 22, function(self, button) OSendToOfficer()	end);
--Copy button
	oilvlbutton("OILVLCopy", L["Export"], f, "OptionsButtonTemplate", "BOTTOMLEFT", 252, 3, 50, 22, function(self, button) OSendToCopy() end);
-- Party / Raid Frame
	local rfb=1; -- raid frame button
	local b4i=0;
	local b4j=0;
	for b4j = 1, 8 do
		for b4i = 1, 5 do
			local button4 = CreateFrame("Button", "OILVLRAIDFRAME"..rfb, f, "SecureActionButtonTemplate")
			button4:SetPoint("TOPLEFT", 10+(b4j-1)*82, -66-(b4i-1)*42)
			button4:SetSize(80,40)
			button4:SetText("")
			button4:SetNormalFontObject("GameFontNormalSmall")			
	
			local ntex4 = button4:CreateTexture()
			ntex4:SetTexture(0.2,0.2,0.2,0.5)
			ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ntex4:SetAllPoints()	
			button4:SetNormalTexture(ntex4)
	
			local htex4 = button4:CreateTexture()
			htex4:SetTexture(0,0,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			button4:SetHighlightTexture(htex4)
	
			local ptex4 = button4:CreateTexture()
			ptex4:SetTexture(0,1,1,0.5)
			ptex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ptex4:SetAllPoints()
			button4:SetPushedTexture(ptex4)
		
			-- Right Click
			button4:SetAttribute("type2", "target");
			button4:SetAttribute("target2", "mouseover");
			
			-- hide tooltips
			button4:SetScript("OnLeave", function(self) 
				OilvlTooltip:Hide()
				OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
				rpsw=false;
				rpunit="";
				Omover2=0;
			end)
			
			button4:SetScript("OnEnter", function(self)
				if not LibQTip:IsAcquired("Oraidprog") then
					local ounit = self:GetAttribute("unit");
					OilvlTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT");
					OilvlTooltip:SetUnit(ounit)
					local i = tonumber(self:GetName():gsub("OILVLRAIDFRAME", "").."");
					if oilvlframedata.spec[i] ~= "" then
						OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
						OilvlTooltip:AddLine(SPECIALIZATION..": |cFF00FF00"..oilvlframedata.spec[i]);
					end
					if oilvlframedata.me[i] ~= "" then
						OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
						OilvlTooltip:AddLine(ENSCRIBE..":\n|cFF00FF00"..oilvlframedata.me[i]);
					end
					if oilvlframedata.mg[i] ~= "" then
						OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
						OilvlTooltip:AddLine(L["Gem"]..":\n|cFF00FF00"..oilvlframedata.mg[i]);
					end
					OilvlTooltip:Show()					
					if not rpsw and CheckInteractDistance(ounit, 1) and UnitExists(ounit) and cfg.oilvlms then
						Omover2=1;						
						ClearAchievementComparisonUnit();
						--print("OnEnter ClearAchievementComparisonUnit")
						OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
						rpsw=true;
						rpunit=ounit;
						SetAchievementComparisonUnit(ounit);
					end
				end
			end)

			-- set role variable
			Oilvlrole[rfb] = button4:CreateTexture("Oilvlrole"..rfb, "OVERLAY", nil, -8);
			Oilvlrole[rfb]:SetSize(15,15);
			Oilvlrole[rfb]:SetPoint("BOTTOMRIGHT",0,0);
			Oilvlrole[rfb]:SetTexture(nil);
			Oilvlrole[rfb]:SetTexCoord(0,0,0,0);
			
			-- set rank variable
			Oilvlrank[rfb] = button4:CreateTexture("Oilvlrank"..rfb, "OVERLAY", nil, -8);
			Oilvlrank[rfb]:SetSize(15,15);
			Oilvlrank[rfb]:SetPoint("TOPLEFT",0,5);
			Oilvlrank[rfb]:SetTexture(nil);
--			Oilvlrank[rfb]:SetTexCoord(0,0,0,0);
			
			-- set mark for send 
			button4:CreateTexture("Oilvlmark"..rfb, "OVERLAY", nil, -8);
			_G["Oilvlmark"..rfb]:SetSize(15,15);
			_G["Oilvlmark"..rfb]:SetPoint("BOTTOMLEFT",0,0);
			_G["Oilvlmark"..rfb]:SetTexture("Interface/RAIDFRAME/ReadyCheck-Ready");
			_G["Oilvlmark"..rfb]:Hide();

			-- Left Click and Middle Click
			button4:RegisterForClicks("LeftButtonDown", "RightButtonDown", "MiddleButtonDown");
			button4:SetScript("PostClick", function(self, button, down) 					
					if button == "LeftButton" or button == "LeftButtonDown" then
						ORfbIlvl(self:GetName():gsub("OILVLRAIDFRAME", "").."") 
					end
					if button == "MiddleButton" or button == "MiddleButtonDown" then
						if _G["Oilvlmark"..self:GetName():gsub("OILVLRAIDFRAME","")]:IsVisible() then
							_G["Oilvlmark"..self:GetName():gsub("OILVLRAIDFRAME","")]:Hide();
						else
							_G["Oilvlmark"..self:GetName():gsub("OILVLRAIDFRAME","")]:Show();
						end
					end
			end);
			rfb = rfb + 1;
		end
	end	
	
-- Oilvl Game Tooltips
	CreateFrame("GameTooltip", "OilvlTooltip", nil, "GameTooltipTemplate" ); -- Tooltip name cannot be nil
	-- Allow tooltip SetX() methods to dynamically add new lines based on these
	OilvlTooltip:AddFontStrings(
		OilvlTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
		OilvlTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" ) );

-- Refresh
	oilvlframesw=true;
	OVILRefresh();
	f:SetScale(0.8);
	f:Hide();
--	tinsert(UISpecialFrames,"OIVLFRAME");
--	f:SetUserPlaced(true);
end
-- OCategory is the expansion title.
-- ORaidname is the raid title.
-- Oprint is to print out the result if true.
-- Example:
-- OilvlGetStatisticId("Warlords of Draenor", "Highmaul", OSTATHM, false)
-- OilvlGetStatisticId("Warlords of Draenor", "Blackrock Foundry", OSTATBF, false)
function OilvlGetStatisticId(OCategory, ORaidName, OTable, Oprint)
	local str = ""
	for _, CategoryId in pairs(GetStatisticsCategoryList()) do
		local Title, ParentCategoryId, Something
		Title, ParentCategoryId, Something = GetCategoryInfo(CategoryId)
		
		if Title == OCategory then
			local i
			local statisticCount = GetCategoryNumAchievements(CategoryId)
			local j=1; -- boss Count
			local k=1; -- difficulties Count
			for i = 1, statisticCount do
				local IDNumber, OOName, _, _, _, _, _, _, _, _, _ = GetAchievementInfo(CategoryId, i)
				if OOName:find(ORaidName) then
					if k == 1 then
						OTable[j] = {}
					end
					OTable[j][k] = IDNumber;
					if k < 4 then
						k = k + 1;
					else
						OTable[j][k+1] = OOName:gsub(" defeats ",""):gsub(" kills ",""):gsub(" destructions ",""):gsub("%(.*%)","").."";
						k = 1;
						j = j + 1;
					end
					if Oprint then
						print(OOName..":"..IDNumber)
					end
				end
			end
		end
	end
end
-- /dump EJ_GetInstanceByIndex(2, true)
local WoD, _, _ = EJ_GetTierInfo(6);
highmaulname, _, _, _, _, _, _ = EJ_GetInstanceInfo(477)
local OSTATHM = {}
OilvlGetStatisticId(WoD, highmaulname, OSTATHM, false)
-- /dump EJ_GetInstanceByIndex(3, true)
local bfname, _, _, _, _, _, _ = EJ_GetInstanceInfo(457)
local OSTATBF = {}
OilvlGetStatisticId(WoD, bfname:sub(1,strlen(bfname)-2), OSTATBF, false)
--OilvlGetStatisticId(WoD, bfname, OSTATBF, false)

-------------------------------------------------------------------------------
-- Font definitions.
-------------------------------------------------------------------------------
-- Setup the Title Font. 14
local ssTitleFont = CreateFont("ssTitleFont")
ssTitleFont:SetTextColor(1,0.823529,0)
ssTitleFont:SetFont(GameTooltipText:GetFont(), 14)

-- Setup the Header Font. 12
local ssHeaderFont = CreateFont("ssHeaderFont")
ssHeaderFont:SetTextColor(1,0.823529,0)
ssHeaderFont:SetFont(GameTooltipHeaderText:GetFont(), 12)

-- Setup the Regular Font. 12
local ssRegFont = CreateFont("ssRegFont")
ssRegFont:SetTextColor(1,0.823529,0)
ssRegFont:SetFont(GameTooltipText:GetFont(), 12)

local orp={};
orp["LFR"]={};
orp["Normal"]={};
orp["Heroic"]={};
orp["Mythic"]={};

function OGetRaidProgression(RaidName, OSTAT, NumRaidBosses)
	local i=0;
	local omatch=false; -- check if some word repeat
	local twohighest=0;
	local progression="";
	local matchi=0; -- line that word repeat + 1
	wipe(orp);
	orp={};
	orp["LFR"]={};
	orp["Normal"]={};
	orp["Heroic"]={};
	orp["Mythic"]={};
	orp["unitname"], orp["unitid"] = GameTooltip:GetUnit();
	orp["oframe"] = GameTooltip:GetOwner();
	if rpunit == "" or not UnitExists("target") or not CheckInteractDistance("target", 1) or orp["oframe"] == nil then 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
		return -1; 
	end
	if orp["unitname"] == nil then 
		ClearAchievementComparisonUnit();
		OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		SetAchievementComparisonUnit("target");
		rpunit = "target";
		rpsw=true;
		return -1; 
	end
	if orp["unitid"] == nil then 
		ClearAchievementComparisonUnit();
		OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		SetAchievementComparisonUnit("target");
		rpunit = "target";
		rpsw=true;
		return -1; 
	end	
	if UnitGUID(rpunit) ~= UnitGUID(orp["unitid"]) then 
		ClearAchievementComparisonUnit();
		OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		SetAchievementComparisonUnit("target");
		rpunit = "target";
		rpsw=true;
		return -1; 
	end
	for i = 2, GameTooltip:NumLines() do
		local msg = _G["GameTooltipTextLeft"..i]:GetText();
		if msg then
			msg = msg:find(RaidName);
		end
		if msg then
			omatch=true;
			matchi=i+1;
			break;
		end
	end	
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine(RaidName);
	end
	local op=0;
	for i = 1, NumRaidBosses do	
		if GetComparisonStatistic(OSTAT[i][4]) ~= "--" then
			op = op + 1;
		end
		orp["Mythic"][i] = GetComparisonStatistic(OSTAT[i][4]);
	end	
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY6.." ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][3]) ~= "--" then
			op = op + 1;
		end
		orp["Heroic"][i] = GetComparisonStatistic(OSTAT[i][3]);
	end
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY2.." ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][2]) ~= "--" then
			op = op + 1;
		end
		orp["Normal"][i] = GetComparisonStatistic(OSTAT[i][2]);
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY1.." ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][1]) ~= "--" then
			op = op + 1;
		end
		orp["LFR"][i] = GetComparisonStatistic(OSTAT[i][1]);
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY3.." ";
		twohighest = twohighest + 1
	end
	if twohighest == 0 then
		progression=progression.."|cFF00FF00 --";
	end
	if not omatch then
		if progression ~= "" then
			GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
			GameTooltip:AddLine(progression);
		end
	else
		_G["GameTooltipTextLeft"..matchi]:SetText(progression);
	end
	OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
	rpsw=false;
	rpunit="";
	
	-- Show raid progression on tooltip:
	if cfg.oilvlrpdetails then
		if LibQTip:IsAcquired("Oraidprog") then
			otooltip:Clear()
		else
			otooltip = LibQTip:Acquire("Oraidprog", 5, "LEFT", "CENTER", "CENTER", "CENTER", "CENTER")
			otooltip:SetBackdropColor(0,0,0,1)
			otooltip:SetHeaderFont(ssHeaderFont)
			otooltip:SetFont(ssRegFont)
			otooltip:ClearAllPoints()
			otooltip:SetClampedToScreen(false)
			otooltip:SetPoint("TOPRIGHT", GameTooltip, "TOPLEFT")
		end
	
		local line = otooltip:AddLine()
		otooltip:SetCell(line, 1, "|cffffffff" ..RaidName.. "|r", "LEFT", 3)
		line = otooltip:AddHeader()
		line = otooltip:SetCell(line, 1, NAME)
		line = otooltip:SetCell(line, 2, PLAYER_DIFFICULTY3)
		line = otooltip:SetCell(line, 3, PLAYER_DIFFICULTY1)
		line = otooltip:SetCell(line, 4, PLAYER_DIFFICULTY2)
		line = otooltip:SetCell(line, 5, PLAYER_DIFFICULTY6)
		otooltip:AddSeparator()

		for m = 1, NumRaidBosses do
			line = otooltip:AddLine()
			line = otooltip:SetCell(line, 1, OSTAT[m][5])
			line = otooltip:SetCell(line, 2, orp["LFR"][m])
			line = otooltip:SetCell(line, 3, orp["Normal"][m])
			line = otooltip:SetCell(line, 4, orp["Heroic"][m])
			line = otooltip:SetCell(line, 5, orp["Mythic"][m])
		end
		otooltip:Show();
	end
end

function OGetRaidProgression2(RaidName, OSTAT, NumRaidBosses)
--	print("OGetRaidProgression2");
	local i=0;
	local omatch=false; -- check if some word repeat
	local twohighest=0;
	local progression="";
	local matchi=0; -- line that word repeat + 1
	wipe(orp);
	orp={};
	orp["LFR"]={};
	orp["Normal"]={};
	orp["Heroic"]={};
	orp["Mythic"]={};
	orp["unitname"], orp["unitid"] = OilvlTooltip:GetUnit();
	orp["oframe"] = OilvlTooltip:GetOwner();
	if orp["oframe"] == nil then 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
		return -1;
	end
	if rpunit == "" or rpunit == "target" or not UnitExists(rpunit) or not UnitExists(orp["unitid"]) or not CheckInteractDistance(rpunit, 1) or not CheckInteractDistance(orp["unitid"], 1) or orp["oframe"]:GetName():gsub("%d","") ~= "OILVLRAIDFRAME" then 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
		return -1; 
	end
	if orp["unitname"] == nil then 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
		return -1;
	end
	if orp["unitid"] == nil then 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
		return -1;
	end
	if UnitGUID(rpunit) ~= UnitGUID(orp["unitid"]) then
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
		return -1;
	end
	local gcs1197 = GetComparisonStatistic(1197)
	if gcs1197 == nil or tonumber(gcs1197) == nil then
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
		return -1;
	end
	orp["spec"] = oilvlframedata.spec[tonumber(orp["oframe"]:GetName():gsub("OILVLRAIDFRAME", "").."")];
	orp["class"], _ =  UnitClass(orp["unitid"]);
	orp["ilvl"] = string.format("%d", oilvlframedata.ilvl[tonumber(orp["oframe"]:GetName():gsub("OILVLRAIDFRAME", "").."")]);
	orp["raidname"]=RaidName;
	orp["progression"]="";
	for i = 2, OilvlTooltip:NumLines() do
		local msg = _G["OilvlTooltipTextLeft"..i]:GetText();
		if msg then
			msg = msg:find(RaidName);
		end
		if msg then
			omatch=true;
			matchi=i+1;
			break;
		end
	end	
	if not omatch and not cfg.oilvlrpdetails then
		OilvlTooltip:SetHeight(OilvlTooltip:GetHeight()+15);
		OilvlTooltip:AddLine(RaidName);
	end
	local op=0;
	for i = 1, NumRaidBosses do	
		if GetComparisonStatistic(OSTAT[i][4]) ~= "--" then
			op = op + 1;
		end
		orp["Mythic"][i] = GetComparisonStatistic(OSTAT[i][4]);
	end	
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY6.." ";
		orp["progression"]=orp["progression"]..op.."/"..NumRaidBosses.."M ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][3]) ~= "--" then
			op = op + 1;
		end
		orp["Heroic"][i] = GetComparisonStatistic(OSTAT[i][3]);
	end
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY2.." ";
		orp["progression"]=orp["progression"]..op.."/"..NumRaidBosses.."H ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][2]) ~= "--" then
			op = op + 1;
		end
		orp["Normal"][i] = GetComparisonStatistic(OSTAT[i][2]);
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY1.." ";
		orp["progression"]=orp["progression"]..op.."/"..NumRaidBosses.."N ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][1]) ~= "--" then
			op = op + 1;
		end
		orp["LFR"][i] = GetComparisonStatistic(OSTAT[i][1]);
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFF"..PLAYER_DIFFICULTY3.." ";
		orp["progression"]=orp["progression"]..op.."/"..NumRaidBosses.."L ";
		twohighest = twohighest + 1
	end
	if twohighest == 0 then
		progression=progression.."|cFF00FF00none";
		orp["progression"]="none";
	end
	if not omatch and not cfg.oilvlrpdetails then
		if progression ~= "" then
			OilvlTooltip:SetHeight(OilvlTooltip:GetHeight()+15);
			OilvlTooltip:AddLine(progression);
		end
	else
		if not cfg.oilvlrpdetails then
			_G["OilvlTooltipTextLeft"..matchi]:SetText(progression);
		end
	end
	OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
	rpsw=false;
	rpunit="";
	Omover2=0;
	
	-- Show raid progression on tooltip:
	if cfg.oilvlrpdetails then
		if LibQTip:IsAcquired("Oraidprog") then
			otooltip2:Clear()
		else
			otooltip2 = LibQTip:Acquire("Oraidprog", 5, "LEFT", "CENTER", "CENTER", "CENTER", "CENTER")
			otooltip2:SetBackdropColor(0,0,0,1)
			otooltip2:SetHeaderFont(ssHeaderFont)
			otooltip2:SetFont(ssRegFont)
			otooltip2:ClearAllPoints()
			otooltip2:SetClampedToScreen(false)
			--[[if GetScreenWidth() - OilvlTooltip:GetRight() < 500 then
				-- show on left
				otooltip2:SetPoint("TOPRIGHT", OilvlTooltip, "TOPLEFT")
				otooltip2:SetAutoHideDelay(0.25, OilvlTooltip:GetOwner());
			else
				-- show on right
				otooltip2:SetPoint("TOPLEFT", OilvlTooltip, "TOPRIGHT")
				otooltip2:SetAutoHideDelay(0.25, OilvlTooltip:GetOwner());
			end]]--
			if GetScreenWidth() - OilvlTooltip:GetRight() < 500 then
				otooltip2:SetPoint("TOPRIGHT", OilvlTooltip:GetOwner(),"BOTTOMLEFT")
			else
				otooltip2:SetPoint("TOPLEFT", OilvlTooltip:GetOwner(),"BOTTOMRIGHT")
			end
			otooltip2:SetAutoHideDelay(0.25, OilvlTooltip:GetOwner());			
			for i = 1, OilvlTooltip:NumLines() do
				if i > 1 and i < 5 then
					otooltip2:AddLine("|cffffffff".._G["OilvlTooltipTextLeft"..i]:GetText());
				else
					otooltip2:AddLine(_G["OilvlTooltipTextLeft"..i]:GetText());
				end
			end
			OilvlTooltip:Hide();
		end	
		local line = otooltip2:AddLine(" ")
		line = otooltip2:AddLine()
		otooltip2:SetCell(line, 1, "|cffffffff" ..orp["unitname"].."("..orp["ilvl"].." "..orp["spec"].." "..orp["class"]..") "..orp["progression"].." "..orp["raidname"].. "|r", "LEFT", 3)
		otooltip2:SetCellScript(line, 1, "OnMouseUp", function() 
			StaticPopupDialogs["COPY_ORP"] = {
				text="Press Ctrl+C to copy",
				button1 = OKAY,
				button2 = nil,
				timeout = 0,
				whileDead = 1,
				hideOnEscape = 1,
				whileDead = 1,
				hasEditBox = 1,
				preferredIndex = 3,
				exclusive = 1,
				maxLetters = 255,
				editBoxWidth = 350,
				OnShow = function (self, data)
					self.editBox:SetText(orp["unitname"].."("..orp["ilvl"].." "..orp["spec"].." "..orp["class"]..") "..orp["progression"].." "..orp["raidname"])
					self.editBox:HighlightText()
					self:SetHeight(16)
				end,
				EditBoxOnEnterPressed = function(self, data)
					StaticPopup_Hide ("COPY_ORP")
				end,
				EditBoxOnEscapePressed = function(self, data)
					StaticPopup_Hide ("COPY_ORP")
				end,				
			}
			StaticPopup_Show ("COPY_ORP")
		end)
		otooltip2:AddSeparator();
		line = otooltip2:AddHeader()
		line = otooltip2:SetCell(line, 1, NAME)
		line = otooltip2:SetCell(line, 2, PLAYER_DIFFICULTY3)
		line = otooltip2:SetCell(line, 3, PLAYER_DIFFICULTY1)
		line = otooltip2:SetCell(line, 4, PLAYER_DIFFICULTY2)
		line = otooltip2:SetCell(line, 5, PLAYER_DIFFICULTY6)
		otooltip2:AddSeparator()

		for m = 1, NumRaidBosses do
			line = otooltip2:AddLine()
			line = otooltip2:SetCell(line, 1, OSTAT[m][5])
			line = otooltip2:SetCell(line, 2, orp["LFR"][m])
			line = otooltip2:SetCell(line, 3, orp["Normal"][m])
			line = otooltip2:SetCell(line, 4, orp["Heroic"][m])
			line = otooltip2:SetCell(line, 5, orp["Mythic"][m])
		end	
		otooltip2:AddSeparator()
		line = otooltip2:AddLine()
		line = otooltip2:SetCell(line, 1, "|cffffffff"..SEND_LABEL)
		line = otooltip2:SetCell(line, 2, "|cffffffff"..CHAT_MSG_GUILD)
		line = otooltip2:SetCell(line, 3, "|cffffffff"..CHAT_MSG_RAID)
		line = otooltip2:SetCell(line, 4, "|cffffffff"..GUILD_RANK1_DESC)
		line = otooltip2:SetCell(line, 5, "|cffffffff"..STATUS_TEXT_TARGET)
		otooltip2:SetCellScript(line, 2, "OnMouseUp", function() 
			SendChatMessage(orp["unitname"].."("..orp["ilvl"].." "..orp["spec"].." "..orp["class"]..") "..orp["progression"].." "..orp["raidname"], "GUILD");
			--print(orp["unitname"]..":"..orp["raidname"].." "..orp["progression"]);
			for m = 1, NumRaidBosses do
				local orpd="";
				if orp["LFR"][m] ~= "--" then orpd=orpd..orp["LFR"][m].."L".." "; end
				if orp["Normal"][m] ~= "--" then orpd=orpd..orp["Normal"][m].."N".." "; end
				if orp["Heroic"][m] ~= "--" then orpd=orpd..orp["Heroic"][m].."H".." "; end
				if orp["Mythic"][m] ~= "--" then orpd=orpd..orp["Mythic"][m].."M".." "; end
				if orpd ~= "" then SendChatMessage(OSTAT[m][5]..":"..orpd, "GUILD"); end
				--if orpd ~= "" then print(OSTAT[m][5]..":"..orpd); end
			end			
		end)
		otooltip2:SetCellScript(line, 3, "OnMouseUp", function() 
			SendChatMessage(orp["unitname"].."("..orp["ilvl"].." "..orp["spec"].." "..orp["class"]..") "..orp["progression"].." "..orp["raidname"], "RAID");
			--print(orp["unitname"]..":"..orp["raidname"].." "..orp["progression"]);
			for m = 1, NumRaidBosses do
				local orpd="";
				if orp["LFR"][m] ~= "--" then orpd=orpd..orp["LFR"][m].."L".." "; end
				if orp["Normal"][m] ~= "--" then orpd=orpd..orp["Normal"][m].."N".." "; end
				if orp["Heroic"][m] ~= "--" then orpd=orpd..orp["Heroic"][m].."H".." "; end
				if orp["Mythic"][m] ~= "--" then orpd=orpd..orp["Mythic"][m].."M".." "; end
				if orpd ~= "" then SendChatMessage(OSTAT[m][5]..":"..orpd, "RAID"); end
				--if orpd ~= "" then print(OSTAT[m][5]..":"..orpd); end
			end			
		end)
		otooltip2:SetCellScript(line, 4, "OnMouseUp", function() 
			SendChatMessage(orp["unitname"].."("..orp["ilvl"].." "..orp["spec"].." "..orp["class"]..") "..orp["progression"].." "..orp["raidname"], "OFFICER");
			--print(orp["unitname"]..":"..orp["raidname"].." "..orp["progression"]);
			for m = 1, NumRaidBosses do
				local orpd="";
				if orp["LFR"][m] ~= "--" then orpd=orpd..orp["LFR"][m].."L".." "; end
				if orp["Normal"][m] ~= "--" then orpd=orpd..orp["Normal"][m].."N".." "; end
				if orp["Heroic"][m] ~= "--" then orpd=orpd..orp["Heroic"][m].."H".." "; end
				if orp["Mythic"][m] ~= "--" then orpd=orpd..orp["Mythic"][m].."M".." "; end
				if orpd ~= "" then SendChatMessage(OSTAT[m][5]..":"..orpd, "OFFICER"); end
				--if orpd ~= "" then print(OSTAT[m][5]..":"..orpd); end
			end			
		end)
		otooltip2:SetCellScript(line, 5, "OnMouseUp", function() 
			if not UnitExists("target") then return -1;	end
			SendChatMessage(orp["unitname"].."("..orp["ilvl"].." "..orp["spec"].." "..orp["class"]..") "..orp["progression"].." "..orp["raidname"], "WHISPER", nil, UnitName("target"));
			--print(orp["unitname"]..":"..orp["raidname"].." "..orp["progression"]);
			for m = 1, NumRaidBosses do
				local orpd="";
				if orp["LFR"][m] ~= "--" then orpd=orpd..orp["LFR"][m].."L".." "; end
				if orp["Normal"][m] ~= "--" then orpd=orpd..orp["Normal"][m].."N".." "; end
				if orp["Heroic"][m] ~= "--" then orpd=orpd..orp["Heroic"][m].."H".." "; end
				if orp["Mythic"][m] ~= "--" then orpd=orpd..orp["Mythic"][m].."M".." "; end
				if orpd ~= "" then SendChatMessage(OSTAT[m][5]..":"..orpd, "WHISPER", nil, UnitName("target")); end
				--if orpd ~= "" then print(OSTAT[m][5]..":"..orpd); end
			end			
		end)
		otooltip2:AddSeparator()
		otooltip2:Show();
--		print(otooltip2:GetWidth());
	end
end

local oenchantItem = {
	[0] = {0, INVTYPE_AMMO},
	[1] = {0, INVTYPE_HEAD},
	[2] = {1, INVTYPE_NECK},
	[3] = {0, INVTYPE_SHOULDER},
	[4] = {0, INVTYPE_BODY},
	[5] = {0, INVTYPE_CHEST},
	[6] = {0, INVTYPE_WAIST},
	[7] = {0, INVTYPE_LEGS},
	[8] = {0, INVTYPE_FEET},
	[9] = {0, INVTYPE_WRIST},
	[10] = {0, INVTYPE_HAND},
	[11] = {1, INVTYPE_FINGER.."1"},
	[12] = {1, INVTYPE_FINGER.."2"},
	[13] = {0, INVTYPE_TRINKET.."1"},
	[14] = {0, INVTYPE_TRINKET.."2"},
	[15] = {1, INVTYPE_CLOAK},
	[16] = {1, INVTYPE_WEAPON},
	[17] = {1, INVTYPE_SHIELD},
}

function OTgathertil(guid, unitid)
	local totalIlvl, avgIlvl = 0
	local iter_min, iter_max = 0
	local itemLevel = 0
	local equipType = 0
	local twoHander = nil
	local mia = 0;
	local count = 0
	local missenchant = "";
	local missgem = "";
	local _,armorname,_ = GetAuctionItemClasses()
	for i = 1,17 do
		if(i ~= SHIRT) then
			local item = GetInventoryItemLink(unitid, i)
			if(item) then
				local upgradeID = ItemUpgradeInfo:GetUpgradeID(item)
				local upgrade = ItemUpgradeInfo:GetCurrentUpgrade(upgradeID)
				_,_,_,itemLevel,_,itemClass,_,_,equipType = GetItemInfo(item)
				

				if(itemLevel) then
					count = count + 1
					if(i == WEP) then
						if(equipType == "INVTYPE_2HWEAPON" or equipType == "INVTYPE_RANGED" or equipType == "INVTYPE_RANGEDRIGHT") then
							twoHander = 1
						end
					end

					-- check miss enchant
					local itemID,enchant,_,_,_,_,_ = item:match("item:(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)");
					if oenchantItem[i][1] == 1 and enchant == "0" then
						if i ~= 17 then
							if missenchant == "" then
								missenchant = missenchant..oenchantItem[i][2]; 
							else
								missenchant = missenchant..", "..oenchantItem[i][2]; 
							end
						else
							if i == 17 and itemClass ~= armorname and  twoHander ~= 1 then
								if missenchant == "" then
									missenchant = missenchant..oenchantItem[i][2]; 
								else
									missenchant = missenchant..", "..oenchantItem[i][2]; 
								end
							end
						end
					end
					
					-- check missing gems
					if OItemAnalysis_CountEmptySockets(item) ~= 0 then
						if missgem == "" then
							missgem = missgem..oenchantItem[i][2]; 
						else
							missgem = missgem..", "..oenchantItem[i][2]; 
						end
					end
					
					if(upgrade == 1) then 
						itemLevel = itemLevel + 4
					elseif(upgrade == 2) then
						itemLevel = itemLevel + 8
					elseif(upgrade == 3) then
						itemLevel = itemLevel + 12
					elseif(upgrade == 4) then
						itemLevel = itemLevel + 16
					end
					if i == 16 or i == 17 then
						local m,n;
						local sw=false;
						for m = 1,3 do
							for n = 1, 10 do
								if GarroshBoA[m][n] == tonumber(itemID) then
									itemLevel = GarroshBoAScaling[UnitLevel(unitid)][m];
									sw=true;
									break;
								end
							end
							if sw then break end
						end
					end
					totalIlvl = totalIlvl + itemLevel
				end
			end
		end
	end
	
	if count < 15 and twoHander then
		mia = 15-count;	
	end
	if count < 16 and not twoHander then
		mia = 16-count;
	end
	
	if((count == 15) and twoHander) then
		avgIlvl = round(totalIlvl / count,1)
	elseif((count == 16) and not twoHander) then
		avgIlvl = round(totalIlvl / count, 1)
	elseif((count == 16) and twoHander) then
		avgIlvl = round(totalIlvl / 16, 1)
	elseif((count == 15) and not twoHander) then
		avgIlvl = round(totalIlvl / 16, 1)
	else
		avgIlvl = round(totalIlvl / 15, 1)
	end
return avgIlvl, mia, missenchant, missgem;
end

function OTInspect(self,event, ...)
	if UnitAffectingCombat("player") == false and event ~= "PLAYER_LEAVING_WORLD" then
		if event == "INSPECT_READY" then
			if OILVL_Unit ~= "" then				
				if CheckInteractDistance(OILVL_Unit, 1) then
					OTilvl, OTmia, missenchant, missgem = OTgathertil(UnitGUID("OILVL_Unit"),OILVL_Unit)
					if (OTmia == 0) then
						miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
						local ntex4 = _G[OTCurrent]:CreateTexture()
						ntex4:SetTexture(0.2,0.2,0.2,0.5)
						ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
						ntex4:SetAllPoints()	
						_G[OTCurrent]:SetNormalTexture(ntex4)
						if missenchant ~= "" or missgem ~= "" then
							oilvlframedata.name[OTCurrent3] = oilvlframedata.name[OTCurrent3]:gsub("!","");
							oilvlframedata.name[OTCurrent3] = "! "..oilvlframedata.name[OTCurrent3]
							oilvlframedata.me[OTCurrent3] = missenchant;
							oilvlframedata.mg[OTCurrent3] = missgem;
						else
							oilvlframedata.name[OTCurrent3] = oilvlframedata.name[OTCurrent3]:gsub("!","");
							oilvlframedata.me[OTCurrent3] = "";
							oilvlframedata.mg[OTCurrent3] = "";
							oilvlframedata.spec[OTCurrent3] = "";
						end
						if oilvlframedata.name[OTCurrent3] ~= "" then
							_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..oilvlframedata.name[OTCurrent3].."\n|r|cFF00FF00"..OTilvl);
							oilvlframedata.ilvl[OTCurrent3] = OTilvl;
							local temp = ospec[GetInspectSpecialization(OILVL_Unit)];
							if temp ~= nil then oilvlframedata.spec[OTCurrent3] = temp;	else oilvlframedata.spec[OTCurrent3] = ""; end
						end
						OTCurrent = "";
						OTCurrent2 = "";
						OTCurrent3 = "";
						ountrack=true;
						OILVL_Unit="";						
					else
						if OTmia < 3 then
							miacount = miacount + 1
							miaunit[miacount] = UnitGUID("OILVL_Unit");
							if miaunit[1] == miaunit[2] and miaunit[2] == miaunit[3] and miaunit[3] == miaunit[4] and miaunit[4] == miaunit[5] and miaunit[5] == miaunit[6] then
								miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
								OILVL_Unit="";
								local ntex4 = _G[OTCurrent]:CreateTexture()
								ntex4:SetTexture(0.2,0.2,0.2,0.5)
								ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
								ntex4:SetAllPoints()	
								_G[OTCurrent]:SetNormalTexture(ntex4)
								if oilvlframedata.name[OTCurrent3] ~= "" then
									_G[OTCurrent]:SetText(oClassColor(OTCurrent2)..oilvlframedata.name[OTCurrent3].."\n|r|cFFFF0000"..OTilvl);
									oilvlframedata.ilvl[OTCurrent3] = OTilvl;
								end
								OTCurrent = "";
								OTCurrent2 = "";
								OTCurrent3 = "";
								ountrack=true;						
							end
						end
					end
				else
					OILVL_Unit="";
					if OTCurrent ~= "" then
						local ntex4 = _G[OTCurrent]:CreateTexture()
						ntex4:SetTexture(0.2,0.2,0.2,0.5)
						ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
						ntex4:SetAllPoints()	
						_G[OTCurrent]:SetNormalTexture(ntex4)
					end
					OTCurrent = "";
					OTCurrent2 = "";
					OTCurrent3 = "";
					ountrack=true;
				end	
			end
			-- GameTooltip		
			if (Omover ==1) and cfg.oilvlms then
				Omover=0;
				if not UnitAffectingCombat("player") and cfg.oilvlms and UnitExists("target") and CheckInteractDistance("target", 1) then
					local oname, _ = GameTooltip:GetUnit();
					if oname ~= nil then oname = oname:gsub("%-.+", ""); else return -1; end
					if oname ~= GetUnitName("target",""):gsub("%-.+", "") then return -1; end
					local OTilvl2, OTmia2, missenchant, missgem = OTgathertil(UnitGUID("target"),"target")
					if (OTmia2 == 0) then
						local i=0;
						local omatch=false;
						local oospec = ospec[GetInspectSpecialization("target")];
						-- spec
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find(SPECIALIZATION..":");
							end
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText(SPECIALIZATION..": |r|cFF00FF00"..oospec);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
							GameTooltip:AddLine(SPECIALIZATION..": |r|cFF00FF00"..oospec);	
						end
						-- item level
						omatch=false;
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find(L["Item Level"]..":");
							end
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText(L["Item Level"]..": |r|cFF00FF00"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
							GameTooltip:AddLine(L["Item Level"]..": |r|cFF00FF00"..OTilvl2);	
						end
					else
						local i=0;
						local omatch=false;
						local oospec = ospec[GetInspectSpecialization("target")];
						-- spec
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Spec:");
							end
							if msg and oospec ~= nil then
								_G["GameTooltipTextLeft"..i]:SetText(L["Item Level"]..": |r|cFF00FF00"..oospec);
								omatch=true;
								break;
							end
						end	
						if not omatch and oospec ~= nil then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
							GameTooltip:AddLine(L["Item Level"]..":".."|r|cFF00FF00"..oospec);	
						end
						-- item level
						omatch=false;						
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find(L["Item Level"]..":");
							end						
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText(L["Item Level"]..": |r|cFFFF0000"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
							GameTooltip:AddLine(L["Item Level"]..": |r|cFFFF0000"..OTilvl2);	
						end
						Oilvltimer:ScheduleTimer(OMouseover,1);
					end
				end
			end
			OILVL:UnregisterEvent("INSPECT_READY")
			ClearInspectPlayer()
		end
		
		if event == "INSPECT_ACHIEVEMENT_READY" then
			if cfg.oilvlms then
				if Omover2 == 1 then
					if UnitExists(rpunit) and CheckInteractDistance(rpunit, 1) and rpsw then
						if cfg.oilvlhm then OGetRaidProgression2(highmaulname, OSTATHM, 7); end
						if cfg.oilvlbf then OGetRaidProgression2(bfname, OSTATBF, 10); end
					else
						OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
						rpsw=false;
						rpunit="";
						Omover2=0;
					end
				else
					if UnitExists("target") and CheckInteractDistance("target", 1)  and rpsw then
						if cfg.oilvlhm then OGetRaidProgression(highmaulname, OSTATHM, 7); end
						if cfg.oilvlbf then OGetRaidProgression(bfname, OSTATBF, 10); end
					else
						OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
						rpsw=false;
						rpunit="";
						Omover2=0;
					end
				end
			end
			OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
			rpsw=false;
			rpunit="";
			Omover2=0;			
		end
		
		if event == "GROUP_ROSTER_UPDATE" then
			--OVILRefresh();
			if oilvlframesw then OResetSendMark(); OilvlCheckFrame(); end
			OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
			rpsw=false;
			rpunit="";
			Omover2=0;
		end
		
		if event == "RAID_ROSTER_UPDATE" then
			--OVILRefresh();
			if oilvlframesw then OResetSendMark(); OilvlCheckFrame(); end
			OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
			rpsw=false;
			rpunit="";
			Omover2=0;
		end
		
		if event == "PLAYER_EQUIPMENT_CHANGED" then
			if oilvlframesw then 
				if IsInRaid() then
					local rnum = GetNumGroupMembers();
					for i = 1, rnum do
						if UnitGUID("player") == oilvlframedata.guid[i] then
							ORfbIlvl(i);
							break;
						end
					end					
				else
					ORfbIlvl(1); 
				end
			end
			OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
			rpsw=false;
			rpunit="";
			Omover2=0;
		end
	end
	
	if event == "VARIABLES_LOADED" then
		cfg = Oilvl_Settings;
		if cfg.oilvlframeP == nil then cfg.oilvlframeP = "TOPLEFT"; end
		if cfg.oilvlframeX == nil then cfg.oilvlframeX = 15; end
		if cfg.oilvlframeY == nil then cfg.oilvlframeY = -60; end
		if cfg.oilvlscale  == nil then cfg.oilvlscale = 0.8; end
		if cfg.oilvlalpha  == nil then cfg.oilvlalpha = 1; end
		if cfg.oilvlhm == nil then cfg.oilvlhm = false; end
		if cfg.oilvlbf == nil then cfg.oilvlbf = true; end
		if cfg.oilvlms == nil then cfg.oilvlms = true; end
		if cfg.oilvlme == nil then cfg.oilvlme = true; end
		if cfg.oilvlcharilvl == nil then cfg.oilvlcharilvl = true; end
		if cfg.oilvlrpdetails == nil then cfg.oilvlrpdetails = true; end
	end
		
	if event == "PLAYER_LOGIN" then
		OilvlConfigFrame();
		oilvlframe();
		Oilvltimer:ScheduleTimer(OVILRefresh,2);
		Oilvltimer:ScheduleRepeatingTimer(oilvlcheckrange,2);
		print("O Item Level (|cFFFFFF00OiLvL|r|cFFFFFFFF) |r|cFF00FF00v"..GetAddOnMetadata("Oilvl","Version").." |r|cFFFFFFFF is loaded.")
		print("|cFF00FF00/oi|r|cFFFFFFFF to display |r|cFFFFFF00OiLvL|r|cFFFFFFFF's frame.");
		print("|cFF00FF00/oicfg|r|cFFFFFFFF to display |r|cFFFFFF00OiLvL|r|cFFFFFFFF's configuration frame.");
		ShowUIPanel(InterfaceOptionsFrame);
		InterfaceOptionsFrame.lastFrame = GameMenuFrame;
		InterfaceOptionsFrameTab2:Click();
		InterfaceOptionsFrameCancel:Click();
		HideUIPanel(GameMenuFrame);
	end
		
	if event == "PLAYER_ENTERING_WORLD" then
		--OVILRefresh();
		if oilvlframesw then Oilvltimer:ScheduleTimer(OilvlCheckFrame,10); end
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2 = 0;
	end
		
	if event == "PLAYER_REGEN_DISABLED" then
		if oilvlframesw then
			local nn=1;
			for nn=1, 40 do
				_G["OILVLRAIDFRAME"..nn]:Disable();
			end
			OILVLREFRESH:Hide();
		end
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2 = 0;
	end
	
	if event == "PLAYER_REGEN_ENABLED" then
		if oilvlframesw then
			local nn=1;
			for nn=1, 40 do
				if not _G["OILVLRAIDFRAME"..nn]  then break; end
				_G["OILVLRAIDFRAME"..nn]:Disable();
				_G["OILVLRAIDFRAME"..nn]:Enable();
			end
			OILVLREFRESH:Show();
			OilvlCheckFrame();
		end
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2 = 0;
	end	
	
	if event == "ROLE_CHANGED_INFORM" then
	local changedPlayer, _, oldrole, role = ...;
		if oilvlframesw then
			if IsInRaid() then
				local rnum = GetNumGroupMembers();
				local i = 1;
				for i = 1, rnum do
					if GetUnitName("raid"..i,true) == changedPlayer then
						OilvlSetRole(i, role);
						if oldrole ~= "NONE" then NumRole[oldrole] = NumRole[oldrole] - 1; end
					end
				end
			elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
				local rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
				if GetUnitName("player",true) == changedPlayer then
					OilvlSetRole(1, role);
					if oldrole ~= "NONE" then NumRole[oldrole] = NumRole[oldrole] - 1; end
				end
				local i = 2;
				for i = 2, rnum do
					if GetUnitName("party"..(i-1),true) == changedPlayer then
						OilvlSetRole(i, role);
						if oldrole ~= "NONE" then NumRole[oldrole] = NumRole[oldrole] - 1; end
					end
				end
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				local rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
				if GetUnitName("player",true) == changedPlayer then
					OilvlSetRole(1, role);
					if oldrole ~= "NONE" then NumRole[oldrole] = NumRole[oldrole] - 1; end
				end
				local i = 2;
				for i = 2, rnum do
					if GetUnitName("party"..(i-1),true) == changedPlayer then
						OilvlSetRole(i, role);
						if oldrole ~= "NONE" then NumRole[oldrole] = NumRole[oldrole] - 1; end
					end
				end
			end	
		end
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;		
	end
	
	if event =="LFG_ROLE_UPDATE" or event == "PLAYER_SPECIALIZATION_CHANGED" then
		if oilvlframesw then OilvlCheckFrame() end
		if not IsInRaid() and not IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and not IsInGroup(LE_PARTY_CATEGORY_HOME) then
			ORfbIlvl(1);
		end
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2=0;
	end
end
	-- Set GameTooltip	
function OMouseover()
	if not UnitExists("target") or not CheckInteractDistance("target", 1) then
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover2 = 0;
		return -1;
	end
	if not UnitAffectingCombat("player") and cfg.oilvlms and oilvlframesw then
		if CheckInteractDistance("target", 1) and CanInspect("target") then
			OILVL:RegisterEvent("INSPECT_READY");
			NotifyInspect("target");
			Omover=1;
			if not rpsw then
				ClearAchievementComparisonUnit();
				OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
				SetAchievementComparisonUnit("target");
				rpunit = "target";
				rpsw=true;
			end
		end
	end
end

function OilvlConfigFrame()
	cfg.frame = CreateFrame("Frame",addon.."OiLvLConfig",InterfaceOptionsFramePanelContainer)
	cfg.frame.name = "O Item Level (OiLvL)"
	InterfaceOptions_AddCategory(cfg.frame)

	local title = cfg.frame:CreateFontString(nil,"ARTWORK","GameFontNormalLarge")
	title:SetPoint("TOPLEFT",16,-16)
	title:SetText("O Item Level (OiLvL) v"..GetAddOnMetadata("Oilvl","Version")) -- can get version from GetAddOnMetadata
	
--  oilvl scale
	local oscale = CreateFrame("Slider", "Oilvlscale", cfg.frame, "OptionsSliderTemplate")
	oscale:SetWidth(200)
	oscale:SetHeight(20)
	oscale:SetOrientation('HORIZONTAL');
	oscale:SetPoint("TOPLEFT",16,-70);
	
	local scaletitle = oscale:CreateFontString(nil,"ARTWORK","GameFontNormal")
	scaletitle:SetPoint("LEFT",oscale,"LEFT",0,35)
	scaletitle:SetText("O Item Level Frame");

	getglobal(oscale:GetName() .. 'Low'):SetText('1'); --Sets the left-side slider text (default is "Low").
	getglobal(oscale:GetName() .. 'High'):SetText('100'); --Sets the right-side slider text (default is "High").
	getglobal(oscale:GetName() .. 'Text'):SetText(L["Scale"]); --Sets the "title" text (top-centre of slider).
	
	oscale:SetMinMaxValues(0, 1);
	oscale:SetValue(cfg.oilvlscale);
	oscale:RegisterForDrag("LeftButton");
	oscale:SetScript("OnDragStop", function(self, button) 
	local n=oscale:GetValue(); 
		if n > 0 then 
			OIVLFRAME:SetScale(n) 
			cfg.oilvlscale = n;
		end
	end);
	oscale:SetScript("OnMouseDown", function(self, button) 
	local n=oscale:GetValue(); 
		if n > 0 then 
			OIVLFRAME:SetScale(n) 
			cfg.oilvlscale = n;
		end
	end);
	
--  oilvl opacity
	local oalpha = CreateFrame("Slider", "Oilvlalpha", cfg.frame, "OptionsSliderTemplate")
	oalpha:SetWidth(200)
	oalpha:SetHeight(20)
	oalpha:SetOrientation('HORIZONTAL');
	oalpha:SetPoint("TOPLEFT",16,-120);
	
	getglobal(oalpha:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(oalpha:GetName() .. 'High'):SetText('1'); --Sets the right-side slider text (default is "High").
	getglobal(oalpha:GetName() .. 'Text'):SetText(OPACITY); --Sets the "title" text (top-centre of slider).
	
	oalpha:SetMinMaxValues(0, 1);
	oalpha:SetValue(cfg.oilvlalpha);
	oalpha:RegisterForDrag("LeftButton");	
	oalpha:SetScript("OnMouseDown", function(self, button) 
	local n=oalpha:GetValue(); 
		OIVLFRAME:SetAlpha(n) 
		cfg.oilvlalpha = n;
	end);
	oalpha:SetScript("OnDragStop", function(self) 
	local n=oalpha:GetValue(); 
		OIVLFRAME:SetAlpha(n) 
		cfg.oilvlalpha = n;
	end);
	
	-- Raid Progression Checkbutton
	local uniquealyzer = 0;
	function createCheckbutton(parent, x_loc, y_loc, displayname)
		uniquealyzer = uniquealyzer + 1;
	
		local checkbutton = CreateFrame("CheckButton", "oicb"..uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
		checkbutton:SetPoint("TOPLEFT", parent, "TOPLEFT", x_loc, y_loc);
		getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
		checkbutton:SetHitRectInsets(0,0,0,0);
		return checkbutton;
	end

	-- Tooltips option
	local mscb = createCheckbutton(cfg.frame, 16, -170, " "..L["Enable Showing item level / raid progression on tooltips"]);
	mscb:SetSize(30,30);
	mscb:SetScript("PostClick", function() 
		cfg.oilvlms = oicb1:GetChecked() 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover=0
		Omover2 = 0;
		if oicb1:GetChecked() then
			oicb2:Enable();
			oicb3:Enable();
			oicb4:Enable();
		else
			oicb2:Disable();
			oicb3:Disable();
			oicb4:Disable();			
		end
	end);
	if cfg.oilvlms then mscb:SetChecked(true) end
	
	-- Highmaul check button
	local hmcb = createCheckbutton(cfg.frame, 16+25, -200, " "..highmaulname);
	hmcb:SetSize(30,30);
	hmcb:SetScript("PostClick", function() 
		cfg.oilvlhm = oicb2:GetChecked() 
		if cfg.oilvlhm then 
			oicb3:SetChecked(false) 
			cfg.oilvlbf = false; 
		end
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover=0
		Omover2 = 0;		
	end);
	if cfg.oilvlhm then hmcb:SetChecked(true) cfg.oilvlbf = false; end

	-- Blackrock Foundry check button
	local bfcb = createCheckbutton(cfg.frame, 120+25, -200, " "..bfname);
	bfcb:SetSize(30,30);
	bfcb:SetScript("PostClick", function() 
		cfg.oilvlbf = oicb3:GetChecked() 
		if cfg.oilvlbf then 
			oicb2:SetChecked(false) 
			cfg.oilvlhm = false; 
		end 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover=0
		Omover2 = 0;		
	end);	
	if cfg.oilvlbf then bfcb:SetChecked(true) cfg.oilvlhm = false; end
	
	-- Raid Progression Details
	local rpdcb = createCheckbutton(cfg.frame, 16+25, -230, " "..L["Enable Showing Raid Progression Details on tooltips"]);
	rpdcb:SetSize(30,30);
	rpdcb:SetScript("PostClick", function() 
		cfg.oilvlrpdetails = oicb4:GetChecked() 
		OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
		rpsw=false;
		rpunit="";
		Omover=0
		Omover2 = 0;	
	end);
	if cfg.oilvlrpdetails then rpdcb:SetChecked(true) end

	if oicb1:GetChecked() then
		oicb2:Enable();
		oicb3:Enable();
		oicb4:Enable();
	else
		oicb2:Disable();
		oicb3:Disable();
		oicb4:Disable();			
	end
	
	-- miss enchant option
	local eercb = createCheckbutton(cfg.frame, 16, -260, " "..L["Enable Sending Enchantment Reminder"]);
	eercb:SetSize(30,30);
	eercb:SetScript("PostClick", function() cfg.oilvlme = oicb5:GetChecked() oilvlercb:SetChecked(cfg.oilvlme) end);
	eercb:SetChecked(cfg.oilvlme);

	-- character frame item level option
	local cfilvlcb = createCheckbutton(cfg.frame, 16, -290, " "..L["Enable Showing Gear Item Level on Character Frame"]);
	cfilvlcb:SetSize(30,30);
	cfilvlcb:SetScript("PostClick", function() cfg.oilvlcharilvl = oicb6:GetChecked() OiLvlPlayer_Update() end);
	if cfg.oilvlcharilvl then cfilvlcb:SetChecked(true) end	
end

--[[Fix for Lua errors with Blizzard_AchievementUI below]]--
local unregistered,reregistered
local function reregisterBlizz()
	if not reregistered then
		AchievementFrameComparison:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		reregistered=true
	end
end
local function unregisterBlizz(name)
	if not unregistered then
		if not name or name=="Blizzard_AchievementUI" then
			AchievementFrameComparison:UnregisterEvent("INSPECT_ACHIEVEMENT_READY")
			hooksecurefunc("InspectAchievements",reregisterBlizz)
			unregistered=true
		end
	end
end
if IsAddOnLoaded("Blizzard_AchievementUI") then
	unregisterBlizz()
else
	hooksecurefunc("LoadAddOn",unregisterBlizz)
end
------------------------------------------------------------------

GameTooltip:HookScript("OnTooltipSetUnit", function() 
--	print("OnTooltipSetUnit");
	if not UnitAffectingCombat("player") and cfg.oilvlms and UnitExists("target") then
		local oname, _ = GameTooltip:GetUnit()
		if oname ~= nil then oname = oname:gsub("%-.+", ""); else return -1; end
		if  oname == GetUnitName("target",""):gsub("%-.+", "") then
			OMouseover();
		end
	end 
end); 

GameTooltip:HookScript("OnHide", function(self) 
--	print("OnTooltipCleared");
	if otooltip ~= nil then
		LibQTip:Release(otooltip)
		otooltip = nil
	end
end)

hooksecurefunc(LibQTip, "Release", function()
--	print("Release");
	local oframe = GetMouseFocus();
	if oframe == nil then return -1 end
	if oframe:GetName() == nil then return -1 end
	if oframe:GetName():gsub("%d","").."" ~= "OILVLRAIDFRAME" then return -1; end
	OilvlRunMouseoverTooltips(oframe)
end
);

SLASH_OILVL_OILVL1 = "/oilvl"

SlashCmdList["OILVL_OILVL"] = function()
	OIVLFRAME:ClearAllPoints();
	OIVLFRAME:SetPoint(cfg.oilvlframeP, cfg.oilvlframeX, cfg.oilvlframeY);
	OIVLFRAME:SetScale(cfg.oilvlscale);
	OIVLFRAME:SetAlpha(cfg.oilvlalpha);
	OIVLFRAME:Show();
end

SLASH_OILVL_OI1 = "/oi"

SlashCmdList["OILVL_OI"] = function()
	OIVLFRAME:ClearAllPoints();
	OIVLFRAME:SetPoint(cfg.oilvlframeP, cfg.oilvlframeX, cfg.oilvlframeY);
	OIVLFRAME:SetScale(cfg.oilvlscale);
	OIVLFRAME:SetAlpha(cfg.oilvlalpha);
	OIVLFRAME:Show();
end

SLASH_OILVL_OICFG1 = "/oicfg"

SlashCmdList["OILVL_OICFG"] = function()
	InterfaceOptionsFrameTab2:Click();
	InterfaceOptionsFrame_OpenToCategory("O Item Level (OiLvL)")
end

-- fix No player named XYZ is currently playing error.
local function SystemSpamFilter(frame, event, message)
	if message:match(string.format(ERR_CHAT_PLAYER_NOT_FOUND_S, "(.+)")) then
		return true
	end	
    return false
end
ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", SystemSpamFilter)
	
OILVL:SetScript("OnEvent", OTInspect)
OILVL:RegisterEvent("PLAYER_LEAVING_WORLD");
OILVL:RegisterEvent("GROUP_ROSTER_UPDATE");
OILVL:RegisterEvent("RAID_ROSTER_UPDATE");
OILVL:RegisterEvent("VARIABLES_LOADED");
OILVL:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
OILVL:RegisterEvent("PLAYER_LOGIN");
OILVL:RegisterEvent("PLAYER_ENTERING_WORLD");
OILVL:RegisterEvent("PLAYER_REGEN_DISABLED");
OILVL:RegisterEvent("PLAYER_REGEN_ENABLED");
OILVL:RegisterEvent("ROLE_CHANGED_INFORM");
OILVL:RegisterEvent("LFG_ROLE_UPDATE");
OILVL:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED");